/***************************************************************************
                          ADM_divx3.cpp  -  description
                             -------------------
            Only works if div4 or div5 codec is used

    begin                : Fri Apr 12 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <string.h>
#include <math.h>
#include "ADM_library/default.h"
#ifdef BIG_ENDIAN
#undef BIG_ENDIAN
#endif
#include "config.h"
#ifdef USE_DIVX
#include "decore.h"
#include "ADM_colorspace/colorspace.h"

#include "ADM_codecs/ADM_codec.h"
#include "ADM_codecs/ADM_divx4.h"
#include "ADM_gui/GUI_decodersettings.h"

//________________________________________________

void decoderDiv3::setParam( void )
{
 
  		
  		  		 if(1==getDivxParams( &_pp,&_hz_deblock,&_vt_deblock,&_dering))
     			{
                   DEC_SET dec_set;

                    // set post processing
                      // set post processing
                    printf("\n PostProcessing changed : %d",_pp);
#ifndef USE_XVID                    
                     dec_set.deblock_hor_luma =_hz_deblock;
                     dec_set.deblock_hor_chr =_hz_deblock;
                     
                     dec_set.deblock_ver_luma =_vt_deblock;
                     dec_set.deblock_ver_chr =_vt_deblock;

                     dec_set.dering_luma =_dering;
                     dec_set.dering_chr =_dering;
#endif                     
                     dec_set.postproc_level =_pp;
                     
    					decore((long int)this, DEC_OPT_SETPP, &dec_set, NULL);
          		}

}
uint8_t     decoderDiv3::uncompress(uint8_t *in,uint8_t *out,uint32_t len,
				uint32_t *flagz)
										
{
uint8_t ret;
//gain:
    decFrame.bitstream = in;
    decFrame.stride = _w;
    decFrame.bmp = out;
    decFrame.length = len;
    decFrame.render_flag = 1;
#if !defined( USE_DIV5) && !defined(USE_XVID)
	  ret = decore((long int)this, DEC_OPT_FRAME_311, &decFrame, &frame_info);	// error while decoding

#else
	  ret = decore((long int)this, DEC_OPT_FRAME, &decFrame, &frame_info);	// error while decoding
#endif
    if (ret != DEC_OK)
      {
	  printf("\n error calling decore :%d!\n",ret);
	  return 0;
      }
       if(flagz)
   	{
       	if(frame_info.intra) *flagz=AVI_KEY_FRAME;
                 else *flagz=0;
      }
      
      _lastQ= 0;
      return 1;

}

//_____________________________________________________

decoderDiv3::~decoderDiv3()
{
     assert(decore((long int)this, DEC_OPT_RELEASE, &decParam, &decMemReqs) ==
	   DEC_OK);

#define FREE(x) if(decParam.buffers.x) free(decParam.buffers.x);

    FREE(mp4_edged_ref_buffers);
    FREE(mp4_edged_for_buffers);
    FREE(mp4_edged_back_buffers);
    FREE(mp4_display_buffers);
    FREE(mp4_state);
    FREE(mp4_tables);
    FREE(mp4_stream);
    FREE(mp4_reference);


}
// constructor for div3, init encoder and stuff
decoderDiv3::decoderDiv3(uint32_t w,uint32_t h) :decoders(w,h)
{
    decParam.x_dim = w;
    decParam.y_dim = h;

#ifdef COLORSPACE_YV12
    decParam.output_format = DEC_YV12;	//
#elif defined( COLORSPACE_YUY2)
    decParam.output_format = DEC_YUY2;	//
#endif
       decParam.time_incr = 15;	// time_incr default value


    assert(decore((long int)this, DEC_OPT_MEMORY_REQS, &decParam, &decMemReqs) ==
	   DEC_OK);

    // the application allocates the data structures and the buffers

#define ALLOCX(x)                                       if(decMemReqs.x##_buffers_size) \
         { \
                   decParam.buffers.x##_buffers =  malloc(decMemReqs.x##_buffers_size); \
            memset(decParam.buffers.x##_buffers, 0,(      decMemReqs.x##_buffers_size) );\
         } \
         else   decParam.buffers.x##_buffers=NULL;
#define ALLOCY(x)  if(decMemReqs.x##_size) {\
         decParam.buffers.x = \
	 malloc(decMemReqs.x##_size); \
         memset(decParam.buffers.x, 0,(decMemReqs.x##_size )); }\
         else decParam.buffers.x=NULL;

		

		ALLOCX(mp4_edged_ref);
		ALLOCX(mp4_edged_for);
		ALLOCX(mp4_edged_back);
		ALLOCX(mp4_display);

		ALLOCY(mp4_state);
		ALLOCY(mp4_tables);
		ALLOCY(mp4_stream);
		ALLOCY(mp4_reference);

    decParam.x_dim = w;
    decParam.y_dim = h;

#ifdef USE_DIV5
    printf("\n Divx5 codec initialized in Divx3 mode \n");
	decParam.codec_version=311;
#else
    printf("\n Divx4/Xvid codec initialized in Divx3 mode \n");

#endif

    assert(decore((long) this, DEC_OPT_INIT, &decParam, NULL) ==
	   DEC_OK);

	   _hz_deblock=_vt_deblock=_dering=_pp=0;

               DEC_SET dec_set;
#ifdef USE_DIV5
   dec_set.postproc_level =8;
    decore((long int)this, DEC_OPT_SETPP, &dec_set, NULL);

#else
	 dec_set.postproc_level = 8;
    decore((long int)this, DEC_OPT_SETPP, &dec_set, NULL);
#endif


  first=0;


}
#endif
