/***************************************************************************
                          ADM_divxEncVBR.cpp  -  description
                             -------------------
    begin                : Sun Jun 16 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <string.h>
#include <math.h>
#include "avi_vars.h"
#include "prototype.h"

#ifdef USE_DIVX
#include "config.h"

#ifdef BIG_ENDIAN
#undef BIG_ENDIAN
#endif
#include "decore.h"

#include "encore2.h"
#include "ADM_colorspace/colorspace.h"
#include "ADM_codecs/ADM_divxEncode.h"
#include "ADM_toolkit/toolkit.hxx"


/*
	allocate and return uncompressed image in buffer

*/
static ENC_PARAM param;
static ENC_FRAME fr;
extern myENC_RESULT res;
extern int codec_warned;

//
//  Initialize the compressor
//
uint8_t divxEncoderVBR::init(uint32_t br,uint32_t fps1000)
{
    UNUSED_ARG(fps1000);
	if(!codec_warned)
 		{
        	GUI_Alert("\n Warning, Divx Codec will try to create a file\nBe Sure to be on a non win32 partition\n and have write access");
          codec_warned=1;
       }
    //---
	_br=br;
    printf(" Compressing %lu x %lu video in CBR %lu\n", _w, _h, _br);
    assert(0 == _init);
    memset(&param, 0, sizeof(param));
    param.x_dim = _w;
    param.y_dim = _h;
    param.framerate = 25.;
    param.bitrate = (long int) _br;
    param.min_quantizer = 2;
    param.max_quantizer = 12;
    param.quality = 5;
    if (ENC_OK != encore(0, ENC_OPT_INIT, &param, 0))
	{
	printf("\n Encoder init failed\n");
	return 0;
	}
    _handle = param.handle;
    _init = 1;
    return 1;
}
//
//	Warning, in that case we push the Q factor throught flags !!!
//
//

uint8_t divxEncoderVBR::encode(
				uint8_t * in,
			    uint8_t * out,
			    uint32_t * len,
       		uint32_t * flags)
{
	uint16_t q;
	uint8_t   kf;

		q=(*flags)>>8;
		kf=(*flags) & 1;
		return encodeVBR(in,out,len,flags,q,kf);
}

uint8_t divxEncoderVBR::encodeVBR(
				uint8_t * in,
			    uint8_t * out,
			    uint32_t * len,
       		uint32_t * flags,
         		uint16_t	 nq,
           	uint8_t forcekey)
{
    int ret;
//    int q;


    assert(_init);
#ifdef COLORSPACE_YV12
    fr.colorspace = ENC_CSP_YV12;
#else
    fr.colorspace = ENC_CSP_YUY2;
#endif
    fr.quant = nq;
    fr.image = in;
    fr.bitstream = out;
    if(forcekey)
		    fr.intra = 1;		// let the codec decide if it is a keyframe
    else
    		fr.intra=0;

    ret = encore(_handle, ENC_OPT_ENCODE_VBR, &fr, &res);
    if (res.is_key_frame)
	*flags = AVI_KEY_FRAME;
    else
	*flags = 0;
    *len = (uint32_t) fr.length;
    if (ret == ENC_OK)
			return 1;

    return 0;
}


#endif
