/***************************************************************************
                          adm_encdivx2p.cpp  -  description
                             -------------------
    begin                : Mon Jul 15 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <unistd.h>

#include <time.h>
#include <sys/time.h>
#include "config.h"



#include "fourcc.h"
#include "avi_vars.h"
#include "ADM_toolkit/toolkit.hxx"

#include "ADM_encoder/ADM_vidEncode.hxx"

//#include "ADM_video/ADM_vidEncode.hxx"

//#include "encore2.h"
#include "ADM_video/ADM_genvideo.hxx"
#include "ADM_encoder/adm_encoder.h"
//#include "ADM_codecs/ADM_divxEncode.h"
//#include "ADM_encoder/adm_encdivx.h"



static const float min_quant_delta=-10.f;
static const float max_quant_delta=5.f;
/*  Limits on stream-level deviation of quantizer ( used to make
	overall bitrate of stream close to requested value ) */
static const float min_rc_quant_delta=.6f;
static const float max_rc_quant_delta=1.5f;

// Compute parameters

uint8_t Encoder::computeParameters( void )
{


	 FILE *fd;
//     double qmul;
     uint32_t  nf,kf,quant,text,motion,total;
     long long ttotal,ttmotion,ttex,complexity;


     	double average_complexity=0;
      	double  qual_multiplier=0;

	assert(_frametogo);
      ttotal=ttmotion=ttex=complexity=0;          		
      fd=fopen(_logname,"rt");
                   	if(!fd)
                    			return 0;

           qual_multiplier=1.f;
	   double tmp;
        	for (uint32_t cf = 0; cf < _frametogo; cf++)
      					{

                      fscanf(fd, "Frame %lu: intra %lu, quant %lu, texture %lu, motion %lu, total %lu\n",
									  &nf,
							    		&kf,
									    &quant,
									    &text,
									    &motion,
									    &total);
    /*
             			if(nf!=(cf+frameStart))
                				{
                             	fclose(fd);
                              	GUI_Alert("Problem reading stat file !!!");
                               	return 0;
                      		}     */
						tmp=text*(qual_multiplier-1);
	
						total+=(long long)floor(tmp);
						text=(uint32_t)floor((double)text*qual_multiplier);

						ttex +=(int64_t)text;
						ttmotion += (int64_t)motion;
						ttotal +=(int64_t)total;
						complexity +=(int64_t)text*quant;
	    	}
	
		average_complexity=complexity/_frametogo;
		
	
		    fprintf(stderr, "frames %lu, texture %lld, motion %lld, total %lld, complexity %llu\n",
       _frametogo, ttex, ttmotion, ttotal, complexity);
		

       entries=new entry[_frametogo];
       assert(entries);

       // re-read again
       // and store the result this time.
       fclose(fd);
      fd=fopen(_logname,"rt");
     	if(!fd)
        			return 0;
              			
		
		for (uint32_t i=0;i<_frametogo;i++)
		{

  			fscanf(fd, "Frame %lu: intra %d, quant %d, texture %d, motion %d, total %d\n",
         &nf, (int *) &(entries[i].is_key_frame), &(entries[i].quant),
			&(entries[i].text_bits), &(entries[i].motion_bits),
			&(entries[i].total_bits));

				entries[i].total_bits += (int)floor((double) entries[i].text_bits*(qual_multiplier-1));
         		entries[i].text_bits  =(int)floor((double)entries[i].text_bits* qual_multiplier);
	 	}

   		fclose(fd);
     	fd=NULL;

      // check
      // it is coherent
	      int64_t   desired_bits,non_text_bits;

        	//desired_bits=(int64_t)bitrate*(int64_t)iNumFrames/framerate;
         // MB --> bits
			uint32_t sizeMB;
  			sizeMB=_param.finalsize;
          desired_bits=sizeMB*1024;
          desired_bits*=1024*8;

			non_text_bits=ttotal  - ttex ;

			if(desired_bits<=non_text_bits)
			{

				printf("Specified bitrate is too low for this clip.\n");
    			return 0;
			  }

			desired_bits -= non_text_bits;
	
		/**
		BRIEF EXPLANATION OF WHAT'S GOING ON HERE.
		We assume that
			text_bits=complexity / quantizer
			total_bits-text_bits = const(complexity)
		where 'complexity' is a characteristic of the frame
		and does not depend much on quantizer dynamics.
		Using this equation, we calculate 'average' quantizer
		to be used for encoding ( 1st order effect ).
		Having constant quantizer for the entire stream is not
		very convenient - reconstruction errors are
		more noticeable in low-motion scenes. To compensate
		this effect, we multiply quantizer for each frame by
			(complexity/average_complexity)^k,
		( k - parameter of adjustment ). k=0 means 'no compensation'
		and k=1 is 'constant bitrate mode'. We choose something in
		between, like 0.5 ( 2nd order effect ).
		**/
 	

  long long new_complexity=0;
  double denominator=0;
		

	for(uint32_t i=0; i<_frametogo; i++)
	{
		float mult;
      	if(entries[i].is_key_frame)
		{
		    if((i+1<_frametogo) && (entries[i+1].is_key_frame))
			mult=1.25;
		    else
			mult=.75;
		}
		else
		{
			mult=entries[i].text_bits*entries[i].quant;
			mult=(float)sqrt(mult/average_complexity);
			
			if(mult<0.5)
			    mult=0.5;
			if(mult>1.5)
			    mult=1.5;
		}

		entries[i].mult=mult;
		entries[i].drop=0;
		new_complexity+=entries[i].text_bits*entries[i].quant;

		denominator+=desired_bits*entries[i].mult/_frametogo;
	}


	

	m_fQuant=((double)new_complexity)/(double)denominator;

	printf("\n Complexity : %f, denominator : %f",   (float)new_complexity,  (float)denominator);

	if(m_fQuant<2) m_fQuant=2;
	if(m_fQuant>15) m_fQuant=15;


		printf( "Total frames: %ld Avg quantizer: %f\n",		_frametogo, m_fQuant);
		printf( "Expecting %12lld bits\n", desired_bits+non_text_bits);

		m_lEncodedBits=m_lExpectedBits=0;

	return 1;

}

uint8_t  Encoder::getQuantVBR(   uint32_t frame,   int64_t previousbits,
					uint16_t *oquant,uint8_t *qf)
{
	double q;
	double dq,tmp;
		
	if(frame>=_frametogo)
		return 0;

	m_lExpectedBits+=(entries[frame].total_bits-entries[frame].text_bits);
	tmp=entries[frame].text_bits*entries[frame].quant/m_fQuant;
	m_lExpectedBits+=(int64_t)floor(tmp);
	m_lEncodedBits+=(int64_t)previousbits;


/*		printf( "Frame %d: PRESENT, complexity %d, quant multiplier %f,  total %d ",
				frame, entries[frame].text_bits*entries[frame].quant,
					entries[frame].mult,previousbits);
 */


	q = m_fQuant * entries[frame].mult;
	if(q<m_fQuant+min_quant_delta) q=m_fQuant+min_quant_delta;
	if(q>m_fQuant+max_quant_delta) q=m_fQuant+max_quant_delta;

	dq = (double)m_lEncodedBits/(double)m_lExpectedBits;
	dq*=dq;
	if(dq<min_rc_quant_delta)
		dq=min_rc_quant_delta;
	if(dq>max_rc_quant_delta)
		dq=max_rc_quant_delta;
	if(frame<20)					// no framerate corrections in first frames
		dq=1;
		
/*  printf( "Progress: expected %12lld, achieved %12lld, dq %f",
			m_lExpectedBits, m_lEncodedBits, dq);*/
	q *= dq;
	*oquant	= (int64_t )floor(q);
	if(*oquant<3) *oquant=3;
	if(*oquant>31) *oquant=31;
	
//  		printf( ", new quant %d, avg q : %f  mult : %f\n", *oquant,m_fQuant,entries[frame].mult);
    *qf=entries[frame].is_key_frame;
 	return 1;
}
