/***************************************************************************
                          adm_encoder.cpp  -  description
                             -------------------
    begin                : Sun Jul 14 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <unistd.h>

#include <time.h>
#include <sys/time.h>
#include <config.h>

#include "gui_action.hxx"
#ifdef USE_FFMPEG
#include "ADM_lavcodec.h"
#endif

#include "fourcc.h"
#include "avi_vars.h"
#include "ADM_toolkit/toolkit.hxx"

#include "ADM_encoder/ADM_vidEncode.hxx"

#include "ADM_video/ADM_genvideo.hxx"
#include "ADM_encoder/adm_encoder.h"

#ifdef USE_DIVX
#include "ADM_codecs/ADM_divxEncode.h"
#include "ADM_encoder/adm_encdivx.h"       

#endif

#ifdef USE_XX_XVID
	#include "ADM_codecs/ADM_xvid.h"
	#include "ADM_encoder/adm_encxvid.h"
extern uint8_t xvid_loaded;
#endif

#ifdef USE_MJPEG
    #include "ADM_codecs/ADM_mjpegEncode.h"
	#include "ADM_encoder/adm_encmjpeg.h"
#endif

#ifdef USE_FFMPEG
    #include "ADM_codecs/ADM_ffmpeg.h"
	#include "ADM_encoder/adm_encffmpeg.h"
#endif


#ifdef USE_DIVX
SelectCodecType current_codec=CodecDivx;
#else
SelectCodecType current_codec=CodecFF;

#endif


static uint8_t nb_encoder=0;



//----------------------------------
Encoder::~Encoder( void )
{
#define CLEAN(x) if(x) { delete [] x;x=NULL;}

		CLEAN(_vbuffer);
		CLEAN(entries);

}
//---------------------------------
void register_Encoders( void )
{
	printf("\n Registering Encoders\n");
	printf(  "*********************\n");
#ifdef USE_DIVX
			nb_encoder++;
			printf("Divx  encoder registred\n");
#endif
#ifdef USE_MJPEG
			nb_encoder++;
			printf("Mjpeg encoder registred\n");

#endif
#ifdef USE_XX_XVID
			if(xvid_loaded)
			{
				nb_encoder++;
				printf("Xvid  encoder registred\n");
			}

#endif
#ifdef USE_FFMPEG
				nb_encoder++;
				printf("FFMPEG  encoder registred\n");
#endif
            printf("\n %d encoder registered\n",nb_encoder);

}
void 	updateSelectedCodec(Action action)
{
		printf("\n new input : %d\n",action);
		switch(action)
				{
					
					case ACT_SelectCodecXvid:
#ifdef USE_XX_XVID
								if(	xvid_loaded)
									current_codec=CodecXvid;
								else
#endif
										current_codec=CodecDivx;								
								return;										
					case ACT_SelectCodecDivx:
										current_codec=CodecDivx;							
								return;
#ifdef  USE_MJPEG
					case ACT_SelectCodecMjpeg : 
							current_codec=CodecMjpeg;	
							return;
#endif									
#ifdef USE_FFMPEG					
					case ACT_SelectCodecFF:	
					  			current_codec=CodecFF;								
					        		return;
					case ACT_SelectCodecFFH263P:	
					  			current_codec=CodecH263P;						
								printf("\n H263P\n");							     
					        		return;					        
					case ACT_SelectCodecFFH263:	
					  			current_codec=CodecH263;								
								printf("\n H263\n");							     
					        		return;					        
					case ACT_SelectCodecHuff:
								current_codec=CodecHuff;								
								printf("\n Huff\n");							     
					        		return;	
							        
#endif
					default:
						assert(0);
						return;
				}
				current_codec=CodecDivx;				         									
}

