/***************************************************************************
                          gui_filter.cpp  -  description
                             -------------------
    begin                : Wed Mar 27 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

#include <gtk/gtk.h>
#include <time.h>
#include <sys/time.h>
#include <assert.h>

#include "fourcc.h"
#include "avio.hxx"
#include "config.h"
#include "avi_vars.h"
#include "ADM_editor/ADM_edit.hxx"
#include "ADM_video/ADM_genvideo.hxx"


/*
 * DO NOT EDIT THIS FILE - it is generated by Glade.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>
#include "fourcc.h"
#include "avio.hxx"
#include "avi_vars.h"
#include "config.h"
#include "ADM_toolkit/toolkit.hxx"
#include "ADM_toolkit/filesel.h"

#include "prototype.h"
#include "ADM_editor/ADM_edit.hxx"
#include "ADM_video/ADM_genvideo.hxx"
#include "ADM_filter/video_filters.h"
#include "ADM_video/ADM_vidPartial.h"
//_______________________________________
static GtkWidget *create_filters (void);
static GtkWidget *create_listFilters (void);

//static void on_add (GtkButton * button, gpointer user_data);
static void on_sel_ok (GtkButton * button, gpointer user_data);
static void on_sel_ko (gpointer data);
static VF_FILTERS new_filter (void);
//static void  on_configure (GtkButton * button, gpointer user_data);
static void on_action (GtkButton * button, gpointer user_data);
static void sel_change (GtkWidget * gtklist, gpointer func_data);
//__________________________________________
static int filterlock;
static int listlock;
static int action;
static int action_parameter;

static GtkWidget *list1;
static GtkWidget *list2;
static int position;

typedef enum gui_act
{
  A_ADD = 1,
  A_CONFIGURE,
  A_UP,
  A_DOWN,
  A_REMOVE,
  A_DONE,
  A_VCD,
  A_SVCD,
  A_DVD,
  A_LOAD,
  A_SAVE,
  A_PREVIEW,
  A_PARTIAL
};

extern void setVCD (void);
extern void setSVCD (void);
extern void setDVD (void);
//___________________________________________
extern FILTER_ENTRY allfilters[MAX_FILTER];
extern uint32_t nb_video_filter;
extern FILTER videofilters[MAX_FILTER];
extern uint32_t nb_active_filter;
extern ADM_Composer *video_body;
// display all currently activated filters
//_______________________________________



int
GUI_handleFilter (void)
{

#ifndef HAVE_ENCODER
  return 0;
}
#else
VF_FILTERS tag;

  GtkWidget *resi;


  // sanity check
  if (nb_active_filter == 0)
    {
      nb_active_filter = 1;
      videofilters[0].filter = new AVDMVideoStreamNull (video_body);
      videofilters[0].name = "Null";
    }

  do
    {
      resi = create_filters ();
      // Now add entries
      //
      action = 0;
      gtk_widget_show (resi);
      filterlock = 0;
      while (!filterlock)
	{
	  gtk_main_iteration ();
	}

      // an action has been selected
      if (filterlock == 1)
	{
	  // First destroy old display
	  gtk_widget_destroy (resi);

	  switch (action)
	    {
	      // Add
	    case A_ADD:
	      tag = new_filter ();
	      if (tag != VF_INVALID)
		{
		videofilters[nb_active_filter].filter=filterCreateFromTag( tag,NULL,
					videofilters[nb_active_filter - 1].filter) ;

		  /*videofilters[nb_active_filter].filter = allfilters[action_parameter].
		    create (videofilters[nb_active_filter - 1].filter, NULL);*/
		  videofilters[nb_active_filter].name = NULL;
		  videofilters[nb_active_filter].tag = tag;
		  videofilters[nb_active_filter].conf = videofilters[nb_active_filter].filter->
		    configure (videofilters[nb_active_filter - 1].filter);
		  nb_active_filter++;
		}
	      break;
	    case A_VCD:
	      setVCD ();
	      break;
	    case A_SVCD:
	      setSVCD ();
	      break;
	    case A_DVD:
	      setDVD ();
	      break;

	    case A_CONFIGURE:
	      void *p;
	      if (action_parameter)
		{
		  p =
		    videofilters[action_parameter].filter->
		    configure (videofilters[action_parameter - 1].filter);
		  if (p)
		    {
		      videofilters[action_parameter].conf = p;
		      updateVideoFilters ();
		    }
		}
	      break;
	    case A_PARTIAL:
	      if (action_parameter)
		{
		  AVDMGenericVideoStream *replace;
		  uint16_t size;
		  uint8_t *conf;
		  conf =
		    videofilters[action_parameter].filter->
		    getBinaryConf (&size);


		  replace =
		    new ADMVideoPartial (videofilters[action_parameter - 1].filter,
					 videofilters[action_parameter].tag,
					 size, conf);
		  replace->configure (videofilters[action_parameter - 1].filter);
		  delete videofilters[action_parameter].filter;
		  videofilters[action_parameter].filter = replace;
		  conf = replace->getBinaryConf (&size);
		  videofilters[action_parameter].conf = conf;
		  videofilters[action_parameter].tag = VF_PARTIAL;

		  updateVideoFilters ();
		}
	      break;
	    case A_UP:
	      if (action_parameter > 1)	// Select file
		{
		  // swap action parameter & action parameter -1
		  FILTER tmp;
		  memcpy (&tmp, &videofilters[action_parameter - 1],
			  sizeof (FILTER));
		  memcpy (&videofilters[action_parameter - 1],
			  &videofilters[action_parameter], sizeof (FILTER));
		  memcpy (&videofilters[action_parameter], &tmp,
			  sizeof (FILTER));
		  updateVideoFilters ();

		}
	      break;
	    case A_DOWN:
	      if (((int) action_parameter < (int) (nb_active_filter - 1))
	          &&(action_parameter)
	      		)	// Select file
		{
		  // swap action parameter & action parameter -1
		  FILTER tmp;
		  memcpy (&tmp, &videofilters[action_parameter + 1],
			  sizeof (FILTER));
		  memcpy (&videofilters[action_parameter + 1],
			  &videofilters[action_parameter], sizeof (FILTER));
		  memcpy (&videofilters[action_parameter], &tmp,
			  sizeof (FILTER));
		  updateVideoFilters ();

		}
	      break;

	    case A_REMOVE:
	      if (action_parameter > 0)
		{
		  // recreate derivated filters
		  for (uint32_t i = action_parameter + 1;
		       i < nb_active_filter; i++)
		    {
		      VF_FILTERS tag;
		      AVDMGenericVideoStream *old;
		      old = videofilters[i - 1].filter;
		      tag = videofilters[i].tag;
		      /*
		         videofilters[i-1].filter=allfilters[        tag].create(
		         videofilters[i-2].filter,  videofilters[i].conf);
		       */
		      videofilters[i - 1].filter = filterCreateFromTag (tag,
									(uint8_t *) videofilters [i].  conf,
									videofilters [i - 2].filter);


		      videofilters[i - 1].conf = videofilters[i].conf;
		      videofilters[i - 1].name = videofilters[i].name;
		      videofilters[i - 1].tag = tag;
		      delete old;
		    }
		  // delete last one
		  delete videofilters[nb_active_filter - 1].filter;
		  nb_active_filter--;

		}
	      break;
	    case A_DONE:
	      filterlock = 0;
	      break;
	    case A_PREVIEW:

	      if (action_parameter > 0)
		{
		  AVDMGenericVideoStream *in;
		  uint32_t w, h, l, f;
		  uint8_t *data;
		  extern uint32_t curframe;
		  in = videofilters[action_parameter].filter;
		  w = in->getInfo ()->width;
		  h = in->getInfo ()->height;
		  data = (uint8_t *) malloc (w * h * 3);
		  in->getFrameNumberNoAlloc (curframe, &l, data, &f);
		  assert (data);
		  GUI_PreviewInit (w, h);
		  while (GUI_PreviewUpdate (data))
		    {
		      gtk_main_iteration ();
		      usleep (50000);
		    }
		  GUI_PreviewEnd ();
		  free (data);
		}

	      break;
	    case A_LOAD:

	      GUI_FileSelRead ("Load set of filters", filterLoad);

	      break;
	    case A_SAVE:
	      if (nb_active_filter < 2)
		{
		  GUI_Alert ("Nothing to save");
		}
	      else

		GUI_FileSelWrite ("Save set of filters", filterSave);
	      break;

	    default:
	      assert (0);
	    }
	}
    }
  while (filterlock == 1);
  if (mode_preview)
    {
      editorReignitPreview ();
    }

  return 1;
}

 // configure button was pushed
//
// Add buton clicked, pop up new window and update list
//______________________________________________________
void
on_action (GtkButton * button, gpointer user_data)
{
  UNUSED_ARG(button);
//  GtkWidget *resi;
  GtkObject *selected;
  int abutton;

  abutton = (int) user_data;

  position = -1;
  GList *dlist = NULL;
  dlist = GTK_LIST (list1)->selection;
  // retrieve the sected filter if any
  while (dlist)
    {
      selected = GTK_OBJECT (dlist->data);
      position =
	gtk_list_child_position (GTK_LIST (list1), GTK_WIDGET (selected));
      dlist = dlist->next;
    }


  printf ("position : %d\n", position);
  switch (abutton)
    {
    case A_ADD:
    case A_REMOVE:
    case A_UP:
    case A_DOWN:
    case A_CONFIGURE:
    case A_DONE:
    case A_PREVIEW:
    case A_VCD:
    case A_SVCD:
    case A_DVD:
    case A_LOAD:
    case A_SAVE:
    case A_PARTIAL:

      action = abutton;
      break;
    default:
      assert (0);
    }
  action_parameter = position + 1;
  filterlock = 1;
}

// pop up list of filters and select one
//__________________________________________
//__________________________________________
VF_FILTERS new_filter (void)
{
  GtkWidget *resi;
  GtkObject *selected;
  int position;
  VF_FILTERS tag;
  position = -1;
  resi = create_listFilters ();
  gtk_widget_show (resi);
  listlock = 0;
  runDialog(&listlock);
  // A filter was selected
  if (listlock == 1)
    {
      // Ok button was clicked, retrieve selected filter
      GList *dlist = NULL;
      dlist = GTK_LIST (list2)->selection;
      while (dlist)
	{
	  selected = GTK_OBJECT (dlist->data);
	  position = gtk_list_child_position (GTK_LIST (list2), GTK_WIDGET (selected));
	  dlist = dlist->next;
	}
    }
  if (listlock > 0)
    gtk_widget_destroy (resi);
  tag=VF_INVALID;   
  
              
  if(position>=0)
	  	{
			int idx=0;
			for(unsigned int i=0;i<nb_video_filter;i++) 
				{
					if((position==idx)&&(allfilters[i].viewable==1)) 
						{
							printf("\n position : %d tag :%d idx:%d\n",position,tag,idx);
							tag=allfilters[i].tag;
							i=nb_video_filter;
						}
					else
     					if(allfilters[i].viewable) idx++;
						
				}

		}
  return tag;
}

//________________________
void
on_sel_ko (gpointer data)
{
  UNUSED_ARG(data);
  on_sel_ok (NULL, (gpointer) 2);
}

//______________________________________________________
void
on_sel_ok (GtkButton * button, gpointer user_data)
{
  UNUSED_ARG(button);
  int res;
  res = (int) user_data;
  if (listlock == 0)
    {
      switch (res)
	{
	  // ok button
	case 1:
	  listlock = 1;
	  break;
	  // kill
	case 2:
	  listlock = -1;
	  break;
	  // cancel
	case 0:
	  listlock = 2;
	  break;
	}
    }
//  printf ("Clicked !");
}

//____________________
// list all available filter
//____________________
GtkWidget *
create_listFilters (void)
{
  GtkWidget *dialog1;
  GtkWidget *dialog_vbox1;
//  GtkWidget *list2;
  GtkWidget *dialog_action_area1;
  GtkWidget *hbox1;
  GtkWidget *button_sel_ok;
  GtkWidget *button_sel_ko;
  //
  GtkWidget *list_item;

  GList *dlist = NULL;

  dialog1 = gtk_dialog_new ();
  gtk_object_set_data_full (GTK_OBJECT (dialog1),
			    "dialog1", dialog1, (GtkDestroyNotify) on_sel_ko);
//  gtk_object_set_data (GTK_OBJECT (dialog1), "dialog1", dialog1);
  gtk_window_set_title (GTK_WINDOW (dialog1), "Select filter");
  gtk_window_set_policy (GTK_WINDOW (dialog1), TRUE, TRUE, FALSE);
  gtk_window_set_modal (GTK_WINDOW (dialog1), 1);
  dialog_vbox1 = GTK_DIALOG (dialog1)->vbox;
  gtk_object_set_data (GTK_OBJECT (dialog1), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  list2 = gtk_list_new ();
  gtk_widget_ref (list2);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "list2", list2,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (list2);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), list2, TRUE, TRUE, 0);

  dialog_action_area1 = GTK_DIALOG (dialog1)->action_area;
  gtk_object_set_data (GTK_OBJECT (dialog1), "dialog_action_area1",
		       dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area1), 10);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "hbox1", hbox1,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), hbox1, TRUE, TRUE, 0);

  button_sel_ok = gtk_button_new_with_label ("OK");
  gtk_widget_ref (button_sel_ok);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "button_sel_ok",
			    button_sel_ok,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_sel_ok);
  gtk_box_pack_start (GTK_BOX (hbox1), button_sel_ok, FALSE, FALSE, 0);
  gtk_widget_set_usize (button_sel_ok, 60, -2);

  button_sel_ko = gtk_button_new_with_label ("Cancel");
  gtk_widget_ref (button_sel_ko);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "button_sel_ko",
			    button_sel_ko,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_sel_ko);
  gtk_box_pack_start (GTK_BOX (hbox1), button_sel_ko, FALSE, FALSE, 0);
  gtk_widget_set_usize (button_sel_ko, 60, -2);

  for (uint32_t i = 0; i < nb_video_filter; i++)
    {
     if(allfilters[i].viewable)
     {
      list_item = gtk_list_item_new_with_label (allfilters[i].name);
      dlist = g_list_append (dlist, list_item);
      gtk_widget_show (list_item);
     }
    }
  gtk_list_append_items (GTK_LIST (list2), dlist);

  gtk_signal_connect (GTK_OBJECT (button_sel_ok), "clicked",
		      GTK_SIGNAL_FUNC (on_sel_ok), (void *) 1);
  gtk_signal_connect (GTK_OBJECT (button_sel_ko), "clicked",
		      GTK_SIGNAL_FUNC (on_sel_ok), (void *) 0);

  gtk_signal_connect (GTK_OBJECT (list2),
		      "selection_changed",
		      GTK_SIGNAL_FUNC (sel_change), NULL);



  return dialog1;
}

void
sel_change (GtkWidget * gtklist, gpointer func_data)
{
  UNUSED_ARG(gtklist);
  UNUSED_ARG(func_data);
}

//______________________________________________________
// handle current selected filters
//________________________________________________________
GtkWidget *
create_filters (void)
{
  GtkWidget *dialog3;
  GtkWidget *dialog_vbox3;
  GtkWidget *hbox4;
//  GtkWidget *list1;
  GtkWidget *vbox6;
  GtkWidget *button_add;
  GtkWidget *button_remove;
  GtkWidget *button_configure;
  GtkWidget *button_up;
  GtkWidget *button_down;
  GtkWidget *button_vcd;
  GtkWidget *button_svcd;
  GtkWidget *button_dvd;
  GtkWidget *button_load;
  GtkWidget *button_save;
  GtkWidget *button_preview;
  GtkWidget *dialog_action_area3;
  GtkWidget *button_ok;
  GtkWidget *button_partial;

  GtkWidget *list_item;
  GList *dlist = NULL;
  GtkAccelGroup *accel_group;

  accel_group = gtk_accel_group_new ();

  dialog3 = gtk_dialog_new ();
  //gtk_object_set_data (GTK_OBJECT (dialog3), "dialog3", dialog3);
  gtk_object_set_data_full (GTK_OBJECT (dialog3), "dialog3", dialog3,
			    on_sel_ko);
  gtk_window_set_modal (GTK_WINDOW (dialog3), TRUE);

  gtk_widget_set_usize (dialog3, 300, -2);
  gtk_window_set_title (GTK_WINDOW (dialog3), "Filters");
  gtk_window_set_policy (GTK_WINDOW (dialog3), TRUE, TRUE, FALSE);

  dialog_vbox3 = GTK_DIALOG (dialog3)->vbox;
  gtk_object_set_data (GTK_OBJECT (dialog3), "dialog_vbox3", dialog_vbox3);
  gtk_widget_show (dialog_vbox3);

  hbox4 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox4);
  gtk_object_set_data_full (GTK_OBJECT (dialog3), "hbox4", hbox4,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox4);
  gtk_box_pack_start (GTK_BOX (dialog_vbox3), hbox4, TRUE, TRUE, 0);

  list1 = gtk_list_new ();
  gtk_widget_ref (list1);
  gtk_object_set_data_full (GTK_OBJECT (dialog3), "list1", list1,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (list1);
  gtk_box_pack_start (GTK_BOX (hbox4), list1, TRUE, TRUE, 0);

  vbox6 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox6);
  gtk_object_set_data_full (GTK_OBJECT (dialog3), "vbox6", vbox6,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox6);
  gtk_box_pack_start (GTK_BOX (hbox4), vbox6, FALSE, TRUE, 0);
  gtk_widget_set_usize (vbox6, 80, -2);

  button_add = gtk_button_new_with_label ("[A]dd");
  gtk_widget_ref (button_add);
  gtk_object_set_data_full (GTK_OBJECT (dialog3), "button6_remove",
			    button_add, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_add);

  gtk_widget_add_accelerator (button_add, "clicked", accel_group,
			      GDK_A, 0, GTK_ACCEL_VISIBLE);


  gtk_box_pack_start (GTK_BOX (vbox6), button_add, FALSE, FALSE, 0);

  button_remove = gtk_button_new_with_label ("[R]emove");
  gtk_widget_ref (button_remove);
  gtk_object_set_data_full (GTK_OBJECT (dialog3), "button_remove",
			    button_remove,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_remove);
  gtk_box_pack_start (GTK_BOX (vbox6), button_remove, FALSE, FALSE, 0);

  gtk_widget_add_accelerator (button_remove, "clicked", accel_group,
			      GDK_R, 0, GTK_ACCEL_VISIBLE);


  button_configure = gtk_button_new_with_label ("[C]onfigure");
  gtk_widget_ref (button_configure);
  gtk_object_set_data_full (GTK_OBJECT (dialog3), "button_configure",
			    button_configure,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_configure);
  gtk_box_pack_start (GTK_BOX (vbox6), button_configure, FALSE, FALSE, 0);

  gtk_widget_add_accelerator (button_configure, "clicked", accel_group,
			      GDK_C, 0, GTK_ACCEL_VISIBLE);


  button_up = gtk_button_new_with_label ("Shift Up");	// thanks sean
  gtk_widget_ref (button_up);
  gtk_object_set_data_full (GTK_OBJECT (dialog3), "button_up", button_up,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_up);
  gtk_box_pack_start (GTK_BOX (vbox6), button_up, FALSE, FALSE, 0);

  button_down = gtk_button_new_with_label ("Shift Down");
  gtk_widget_ref (button_down);
  gtk_object_set_data_full (GTK_OBJECT (dialog3), "button_down", button_down,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_down);
  gtk_box_pack_start (GTK_BOX (vbox6), button_down, FALSE, FALSE, 0);

  button_vcd = gtk_button_new_with_label ("VCD res");
  gtk_widget_ref (button_vcd);
  gtk_object_set_data_full (GTK_OBJECT (dialog3), "button_vcd", button_vcd,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_vcd);
  gtk_box_pack_start (GTK_BOX (vbox6), button_vcd, FALSE, FALSE, 0);

  button_svcd = gtk_button_new_with_label ("SVCD res");
  gtk_widget_ref (button_svcd);
  gtk_object_set_data_full (GTK_OBJECT (dialog3), "button_svcd", button_svcd,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_svcd);
  gtk_box_pack_start (GTK_BOX (vbox6), button_svcd, FALSE, FALSE, 0);

  button_dvd = gtk_button_new_with_label ("DVD res");
  gtk_widget_ref (button_dvd);
  gtk_object_set_data_full (GTK_OBJECT (dialog3), "button_dvd", button_dvd,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_dvd);
  gtk_box_pack_start (GTK_BOX (vbox6), button_dvd, FALSE, FALSE, 0);



  button_save = gtk_button_new_with_label ("[S]ave");
  gtk_widget_ref (button_save);
  gtk_object_set_data_full (GTK_OBJECT (dialog3), "button_save", button_save,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_save);
  gtk_box_pack_start (GTK_BOX (vbox6), button_save, FALSE, FALSE, 0);

  gtk_widget_add_accelerator (button_save, "clicked", accel_group,
			      GDK_S, 0, GTK_ACCEL_VISIBLE);


  button_load = gtk_button_new_with_label ("[L]oad");
  gtk_widget_ref (button_load);
  gtk_object_set_data_full (GTK_OBJECT (dialog3), "button_load", button_load,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_load);
  gtk_box_pack_start (GTK_BOX (vbox6), button_load, FALSE, FALSE, 0);

  gtk_widget_add_accelerator (button_load, "clicked", accel_group,
			      GDK_L, 0, GTK_ACCEL_VISIBLE);
  //--  
  button_partial = gtk_button_new_with_label ("[P]artial");
  gtk_widget_ref (button_partial);
  gtk_object_set_data_full (GTK_OBJECT (dialog3), "button_partial",
			    button_partial,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_partial);
  gtk_box_pack_start (GTK_BOX (vbox6), button_partial, FALSE, FALSE, 0);

  gtk_widget_add_accelerator (button_partial, "clicked", accel_group,
			      GDK_P, 0, GTK_ACCEL_VISIBLE);

  //--
  button_preview = gtk_button_new_with_label ("Preview");
  gtk_widget_ref (button_preview);
  gtk_object_set_data_full (GTK_OBJECT (dialog3), "button_preview",
			    button_preview,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_preview);
  gtk_box_pack_start (GTK_BOX (vbox6), button_preview, FALSE, FALSE, 0);


  dialog_action_area3 = GTK_DIALOG (dialog3)->action_area;
  gtk_object_set_data (GTK_OBJECT (dialog3), "dialog_action_area3",
		       dialog_action_area3);
  gtk_widget_show (dialog_action_area3);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area3), 10);

  button_ok = gtk_button_new_with_label ("Done");
  gtk_widget_ref (button_ok);
  gtk_object_set_data_full (GTK_OBJECT (dialog3), "button_ok", button_ok,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_ok);
  gtk_box_pack_start (GTK_BOX (dialog_action_area3), button_ok, FALSE, FALSE,
		      0);

  for (uint32_t i = 1; i < nb_active_filter; i++)
    {
      list_item =
	gtk_list_item_new_with_label (videofilters[i].filter->printConf ());
      dlist = g_list_append (dlist, list_item);
      gtk_widget_show (list_item);
    }
  gtk_list_append_items (GTK_LIST (list1), dlist);

  gtk_signal_connect (GTK_OBJECT (button_add), "clicked",
		      GTK_SIGNAL_FUNC (on_action), (void *) A_ADD);
  gtk_signal_connect (GTK_OBJECT (button_configure), "clicked",
		      GTK_SIGNAL_FUNC (on_action), (void *) A_CONFIGURE);
  gtk_signal_connect (GTK_OBJECT (button_remove), "clicked",
		      GTK_SIGNAL_FUNC (on_action), (void *) A_REMOVE);

  gtk_signal_connect (GTK_OBJECT (button_up), "clicked",
		      GTK_SIGNAL_FUNC (on_action), (void *) A_UP);
  gtk_signal_connect (GTK_OBJECT (button_vcd), "clicked",
		      GTK_SIGNAL_FUNC (on_action), (void *) A_VCD);
  gtk_signal_connect (GTK_OBJECT (button_svcd), "clicked",
		      GTK_SIGNAL_FUNC (on_action), (void *) A_SVCD);
  gtk_signal_connect (GTK_OBJECT (button_dvd), "clicked",
		      GTK_SIGNAL_FUNC (on_action), (void *) A_DVD);
  gtk_signal_connect (GTK_OBJECT (button_down), "clicked",
		      GTK_SIGNAL_FUNC (on_action), (void *) A_DOWN);
  gtk_signal_connect (GTK_OBJECT (button_ok), "clicked",
		      GTK_SIGNAL_FUNC (on_action), (void *) A_DONE);
  gtk_signal_connect (GTK_OBJECT (button_preview), "clicked",
		      GTK_SIGNAL_FUNC (on_action), (void *) A_PREVIEW);

  gtk_signal_connect (GTK_OBJECT (button_save), "clicked",
		      GTK_SIGNAL_FUNC (on_action), (void *) A_SAVE);
  gtk_signal_connect (GTK_OBJECT (button_load), "clicked",
		      GTK_SIGNAL_FUNC (on_action), (void *) A_LOAD);
  gtk_signal_connect (GTK_OBJECT (button_partial), "clicked",
		      GTK_SIGNAL_FUNC (on_action), (void *) A_PARTIAL);

  gtk_window_add_accel_group (GTK_WINDOW (dialog3), accel_group);


  return dialog3;
}

#endif
