/***************************************************************************
                          ADM_mpegscan.h  -  description
                             -------------------
    begin                : Sat Oct 12 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef ADM_mpeg2dec
#define ADM_mpeg2dec
 
#define MP2D_BUFFER_SIZE 1024*1024
// MG cache is now the maximum of B-frame in the file
#define MG_CACHE 8

#define ES_ONLY
#include "ADM_mpeg2dec/ADM_mpegpacket.h"

typedef struct
{
	uint8_t type;
	uint64_t offset;			// offset / stream
	uint64_t absoffset;  // offset / file
	uint32_t size;		
}MFrame;
typedef struct 
{
	uint32_t index,real;

}MRenumber;

 class mpeg2decHeader : public vidHeader
{
protected:
	uint8_t			dumpCache (void );	
	uint8_t			asyncJump(uint32_t frame)	;
public:

				mpeg2decHeader(void);
				~mpeg2decHeader();
//  static int checkFourCC(uint8_t *in, uint8_t *fourcc);

virtual   void 				Dump(void);
virtual   uint32_t 		getNbStream(void);
virtual   uint8_t 			needDecompress(void);

// AVI io
virtual 	uint8_t			open(char *name);
virtual 	uint8_t			close(void);
  //__________________________
  //				 Info
  //__________________________
  
  //__________________________
  //				 Audio
  //__________________________

virtual 	WAVHeader *getAudioInfo(void )  ;
virtual 	uint8_t			getAudioStream(AVDMGenericAudioStream **audio);

// Frames
  //__________________________
  //				 video
  //__________________________

virtual 	uint8_t  setFlag(uint32_t frame,uint32_t flags);
virtual 	uint8_t  getFrameSize(uint32_t frame,uint32_t *size);
virtual 	uint32_t getFlags(uint32_t frame,uint32_t *flags);			
virtual 	uint8_t  getFrameNoAlloc(uint32_t framenum,uint8_t *ptr,uint32_t* framelen,
												uint32_t *flags);
virtual 	uint8_t  	getFrameNoAlloc(uint32_t framenum,uint8_t *ptr,uint32_t* framelen)	;


// index and stuff

// New write avi engine
	     	 		
private:
					uint8_t _video_track_id;
					uint32_t _frame_in_queue;
					uint8_t *_end;
					uint8_t _buffer[MP2D_BUFFER_SIZE];
					uint32_t	_lastSendFrame;
					
          void 						decode_mpeg2 (uint8_t * buf, uint8_t * end)   ;
          
          
          // init ...
          uint8_t 					init_codec( void);
          uint8_t 					kill_codec( void);
          void 					setFather( mpeg2decHeader *f);
          void					restart( void );

          // feed mpeg2dec          
          uint8_t  					feedData(uint32_t size);

					// cache handling
	uint8_t 						isInCache(uint32_t frame, uint8_t *no);
	uint32_t 						getSmallerCached(void);
        uint8_t 						getCacheEntry(uint32_t frame, uint8_t *no);          
	uint8_t 						purgeCache(void);     	  
    	uint64_t						_offset[MG_CACHE];
	uint32_t						_frameno[MG_CACHE];
	uint8_t						*_frame[MG_CACHE];			    
	uint32_t						_awaited;
			    
			    // Deals with frame
          uint8_t  					pop (void);
          uint8_t  					popI (void);
        
		        
        virtual 	uint8_t  			getRaw(uint32_t framenum,uint8_t *ptr,uint32_t* framelen);
	virtual 	uint8_t   			getRawStart(uint8_t *ptr,uint32_t *len);
																
         
//          void 							setPTS(uint8_t u);
		      	uint32_t					_nbFrames;		      
			uint32_t					_lastFrame;
			uint32_t 					_nbIFrame;
		      	uint32_t					_startSeqLen;
		      	uint8_t					_ignore;
		        uint8_t					renumber(uint32_t nb);
		      	uint8_t   					gotcha(uint32_t frame,uint8_t *out);		      	          	
		      
		      class AVDMMpeg2decAudioStream *_audioStream;
		      void						*_decoder;
		      
		    
		       ADM_mpegDemuxer		*demuxer;
   		      MFrame					*_indexMpeg;
		      MFrame					*_indexMpegPTS;
		      
		      uint8_t					*_startSeq;
		      uint32_t					_pagesize;
		      
		
           
public:
			uint8_t 					push(uint8_t *in)			    ;

};
#endif
