/***************************************************************************
                          toolkit.cpp  -  description
                             -------------------



    begin                : Fri Dec 14 2001
    copyright            : (C) 2001 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <unistd.h>
#include <sys/time.h>
#include <gtk/gtk.h>

#include "avi_vars.h"
#include "toolkit.hxx"
#include "interface.h"
#include "toolkit.hxx"

void alert_cb_ok(void);
void alert_cb_destroyed(void);
void alert_cb_ko(void);


GtkWidget *GUI_PixmapButtonDefault(GdkWindow * window, const gchar ** xpm,
				   const gchar * tooltip);
GtkWidget *GUI_PixmapButton(GdkWindow * window, const gchar ** xpm,
			    const gchar * tooltip, gint border);


static int wait_gui;
static int destroy_flag;
static int beQuiet=0;

GtkTooltips *tooltips = NULL;

void GUI_Quiet( void )
{
	beQuiet=1;
	
}

void GUI_Verbose( void )
{
	beQuiet=0;
	
}
//_________________________________
// Simple GTK toolkit such as YES/NO or alert window
//_________________________________
void GUI_Alert(const char *alertstring)
{
    GtkWidget *window1;
    GtkWidget *vbox1;
    GtkWidget *label2;
    GtkWidget *button1;

    if(beQuiet) return;
    
    window1 = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    gtk_object_set_data(GTK_OBJECT(window1), "window1", window1);
    gtk_window_set_title(GTK_WINDOW(window1), "Alert");
    gtk_widget_set_usize(window1, 200, 70);
    gtk_window_set_modal(GTK_WINDOW(window1), 1);

    vbox1 = gtk_vbox_new(FALSE, 0);
    gtk_widget_ref(vbox1);
    gtk_object_set_data_full(GTK_OBJECT(window1), "vbox1", vbox1,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(vbox1);
    gtk_container_add(GTK_CONTAINER(window1), vbox1);

    label2 = gtk_label_new(alertstring);
    gtk_widget_ref(label2);
    gtk_object_set_data_full(GTK_OBJECT(window1), "label2", label2,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(label2);
    gtk_box_pack_start(GTK_BOX(vbox1), label2, FALSE, FALSE, 0);

    button1 = gtk_button_new_with_label("OK");
    gtk_widget_ref(button1);
    gtk_object_set_data_full(GTK_OBJECT(window1),
			     "window1", window1,
			     (GtkDestroyNotify) alert_cb_destroyed);
   

    gtk_signal_connect(GTK_OBJECT(button1),
		       "button_press_event", GTK_SIGNAL_FUNC(alert_cb_ok),
		       0);
		gtk_widget_show(button1);		       
     
    
    gtk_box_pack_start(GTK_BOX(vbox1), button1, FALSE, FALSE, 0);
     
     GTK_WIDGET_SET_FLAGS (button1, GTK_CAN_DEFAULT);
     gtk_widget_grab_default (button1);

    gtk_widget_show(window1);
//  printf("\n Waiting to be unlocked");
    wait_gui = 0;
    destroy_flag = 0;
    runDialog(&wait_gui);
    if (!destroy_flag)
	gtk_widget_destroy(window1);

}

//_________________________________
// Call back for press/ destroy
//_________________________________
void alert_cb_ok(void)
{

    wait_gui = 1;

}

void alert_cb_destroyed(void)
{

    wait_gui = -1;
    destroy_flag = 1;

}

void alert_cb_ko(void)
{

    wait_gui = -1;

}

//
//_______________________________
int GUI_Question(const char *alertstring)
{
    GtkWidget *window1;
    GtkWidget *vbox1;
    GtkWidget *label2;
    GtkWidget *button1;
    GtkWidget *button2;
    int ret;
    
    
    // we always answer no in quiet mode
     if(beQuiet) return 0;
     
     
    window1 = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    gtk_object_set_data(GTK_OBJECT(window1), "window1", window1);
    gtk_window_set_title(GTK_WINDOW(window1), "Alert");
    gtk_widget_set_usize(window1, 200, 70);
    gtk_window_set_modal(GTK_WINDOW(window1), 1);

    vbox1 = gtk_vbox_new(FALSE, 0);
    gtk_widget_ref(vbox1);
    gtk_object_set_data_full(GTK_OBJECT(window1), "vbox1", vbox1,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(vbox1);
    gtk_container_add(GTK_CONTAINER(window1), vbox1);

    label2 = gtk_label_new(alertstring);
    gtk_widget_ref(label2);
    gtk_object_set_data_full(GTK_OBJECT(window1), "label2", label2,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(label2);
    gtk_box_pack_start(GTK_BOX(vbox1), label2, FALSE, FALSE, 0);

    button1 = gtk_button_new_with_label("Yes");
    gtk_widget_ref(button1);
    gtk_object_set_data_full(GTK_OBJECT(window1),
			     "window1", window1,
			     (GtkDestroyNotify) alert_cb_destroyed);

    gtk_signal_connect(GTK_OBJECT(button1),
		       "button_press_event", GTK_SIGNAL_FUNC(alert_cb_ok),
		       0);

    gtk_widget_show(button1);
    gtk_box_pack_start(GTK_BOX(vbox1), button1, FALSE, FALSE, 0);
//
    button2 = gtk_button_new_with_label("No");
    gtk_widget_ref(button2);
    gtk_signal_connect(GTK_OBJECT(button2),
		       "button_press_event", GTK_SIGNAL_FUNC(alert_cb_ko),
		       0);

    gtk_widget_show(button2);
    gtk_box_pack_start(GTK_BOX(vbox1), button2, FALSE, FALSE, 0);



    gtk_widget_show(window1);
//  printf("\n Waiting to be unlocked");
    wait_gui = 0;
    destroy_flag = 0;
    runDialog(&wait_gui);
    ret = wait_gui+1;
    if (!destroy_flag)
	gtk_widget_destroy(window1);

    return ret;
}

//
GtkWidget *GUI_PixmapButtonDefault(GdkWindow * window, const gchar ** xpm,
				   const gchar * tooltip)
{
    return GUI_PixmapButton(window, xpm, tooltip, 2);
}

//____________________________________________
//  Used to pack an icon onto a button
//  Adapted from GTK API tutorial
//____________________________________________
GtkWidget *GUI_PixmapButton(GdkWindow * window, const gchar ** xpmd,
			    const gchar * tooltip, gint border)
{
    GtkWidget *button;
    GtkWidget *pixmap;
    GdkPixmap *xpm;
    GdkBitmap *mask;

    xpm = gdk_pixmap_create_from_xpm_d(window, &mask, NULL, (gchar **)xpmd);
    pixmap = gtk_pixmap_new(xpm, mask);
    button = gtk_button_new();

    gtk_container_set_border_width(GTK_CONTAINER(button), border);
    gtk_container_add(GTK_CONTAINER(button), pixmap);

    if (tooltips == NULL)
	tooltips = gtk_tooltips_new();
    if (tooltip != NULL)
	gtk_tooltips_set_tip(tooltips, button, tooltip, NULL);

    gtk_widget_show_all(button);

    return button;
}

//
//    Sleep for n ms
//
void GUI_Sleep(uint32_t ms)
{
    if (ms < 10)
	return;

    ms -= 10;
    timespec ts, tr;
    ts.tv_sec = 0;
    ts.tv_nsec = ms * 1000 * 1000;
    nanosleep(&ts, &tr);
    
}

void MenuAppend(GtkMenu * menu, const char *text)
{
    GtkWidget *glade_menuitem;

    glade_menuitem = gtk_menu_item_new_with_label(text);
    gtk_widget_show(glade_menuitem);
    gtk_menu_append(GTK_MENU(menu), glade_menuitem);

}

void runDialog(volatile int *lock)
{
	
	      while (!*lock)
	      {
				while (gtk_events_pending())    		  	gtk_main_iteration();         
        		usleep(  50000L);			// wait 50 ms
        	}
}


// Get tick (in ms)
// Call with a 0 to initialize
// Call with a 1 to read
//_____________________
uint32_t getTime(int called)
{

    static struct timeval timev_s;

    static struct timeval timev;
    static struct timezone timez;

    int32_t tt;

    if (!called)
      {
	  called = 1;
	  gettimeofday(&timev_s, &timez);
	  return 0;
      }
    gettimeofday(&timev, &timez);
    tt = timev.tv_usec - timev_s.tv_usec;
    tt /= 1000;
    tt += 1000 * (timev.tv_sec - timev_s.tv_sec);
    return (tt);
}
uint32_t getTimeOfTheDay(void)
{
  

     struct timeval timev;
     struct timezone timez;

    int32_t tt;

   
    gettimeofday(&timev, &timez);
    tt = timev.tv_usec;
    tt /= 1000;
    tt += 1000 * (timev.tv_sec);
    return (tt&0xffffff);

}
//EOF
