/***************************************************************************
                          ADM_guiCrop.cpp  -  description
                             -------------------
    begin                : Sun Mar 24 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

#include <gtk/gtk.h>
#include <time.h>
#include <sys/time.h>
#include <assert.h>

#include "fourcc.h"
#include "avio.hxx"
#include "config.h"
#include "avi_vars.h"
#ifdef HAVE_ENCODER


#include "ADM_editor/ADM_edit.hxx"
#include "ADM_video/ADM_genvideo.hxx"
#include "ADM_video/ADM_resizebis.hxx"

extern void yv12rgb(uint8_t *in,uint8_t *out,uint32_t w, uint32_t h);

extern void GUI_RGBDisplay(uint8_t * dis, uint32_t w, uint32_t h, void *widg);

static void 				gui_ko(GtkButton * button, gpointer user_data);
static void 				gui_ok(GtkButton * button, gpointer user_data);
static int 					getCropParams(	uint32_t *w,uint32_t 	*w2, uint32_t *h,uint32_t *h2,uint32_t tw,
											uint32_t th,uint8_t *in,uint8_t *copy);
static GtkWidget  *create_dialog4 (void);
static gboolean  			gui_draw(GtkWidget * widget,
			     GdkEventExpose * event, gpointer user_data);
static void gui_update(GtkButton * button, gpointer user_data);

static int croplock;

static   GtkWidget *entry_x, *entryy,*entry_x2,*entry_y2;
static  GtkWidget *drawingarea9=NULL;;

// Ugly !
static uint32_t globalw=0,globalh=0;
static uint8_t *globalvideo,*globalsource;

static void gui_autocrop(GtkButton * button, gpointer user_data);

void *AVDMVideoStreamCrop::configure( AVDMGenericVideoStream *instream)

{
CROP_PARAMS *par;
uint32_t w,h,l,f;

uint8_t *video1,*video2;

							video1=video2=NULL;

		                 // Get info from previous filter
							w=_in->getInfo()->width;
							h= _in->getInfo()->height;

							printf("\n Crop in : %lu  x %lu\n",w,h);

							video2=(uint8_t *)malloc(w*h*3);							
							assert(video2);
							video1=(uint8_t *)malloc(w*h*3);							
							assert(video1);

							// ask current frame from previous filter
							assert(instream->getFrameNumberNoAlloc(curframe, &l,
          																				video2,&f));
						
							// From now we work in RGB !
                         yv12rgb(video2,video1, w,h);

							
							
			par=_param;
		
    	 	switch(getCropParams(&par->cropx,&par->cropx2,&par->cropy,&par->cropy2,
     							w,h,(uint8_t *)video1,video2) )
				{
				case 0:
		      		printf("cancelled\n");	       	
					break;
				case 1:
					_info.width=_in->getInfo()->width-_param->cropx-_param->cropx2;
					_info.height=_in->getInfo()->height-_param->cropy-_param->cropy2;			
					break;
				default:
					assert(0);
				}
		
					free(video1);
					free(video2);
					video1=video2=NULL;

					return (void *)par;
}
//
//      Get crop parameters from GUI
//                         left, right, top, down , initial size
//
int getCropParams(	uint32_t *w,uint32_t 	*w2, uint32_t *h,uint32_t *h2,uint32_t tw,uint32_t th,
									uint8_t *video,uint8_t *video2)
{
char 	string[50];
gchar   *str;
static 	GtkWidget *resi;
int 	ret;
uint32_t 	iw,iw2,ih,ih2;

		iw=*w;
		ih=*h;
		iw2=*w2;
		ih2=*h2;
		globalw=tw;
		globalh=th;
		globalvideo=video2;	
		globalsource=video;	

		memcpy(globalvideo,video,globalw*globalh*3);				
	
    	printf("\n glox %lu x %lu\n",globalw,globalh);
		do
		{
			croplock=0;
			resi=create_dialog4();
			gtk_widget_set_usize(drawingarea9, tw, th);

		
#define SET_(x,y) 			sprintf(string, "%lu", x); gtk_editable_delete_text(GTK_EDITABLE(y),0,-1); \
		gtk_editable_insert_text(GTK_EDITABLE(y), string, strlen(string), &ret);
		SET_(ih,entryy);
		SET_(ih2,entry_y2);
		SET_(iw,entry_x);
		SET_(iw2,entry_x2);		
		
	  	gtk_widget_show(resi);
		GUI_RGBDisplay(globalvideo, tw,th,( void *)drawingarea9);

		while(!croplock)
		{
			gtk_main_iteration();
		}
		// now check parameters
		//
		if(1==croplock) //         ok button
		{
#define GET_(x,y) str=gtk_editable_get_chars(GTK_EDITABLE(y), 0, -1); \
		      x = (uint32_t) atoi((char *)str);
		
		      GET_(iw,entry_x);
		      GET_(ih,entryy);
		      GET_(iw2,entry_x2);
		      GET_(ih2,entry_y2);
		
			// must be even
			if( (iw&1) || (ih&1) || (iw2&1) || (ih2&1)||(( iw+iw2  )>=tw) || ( (ih+ih2)>=th ))
				{
					croplock=0;
				}
		}
		// cancel button
		if(croplock!=-1)
		{
		 	gtk_widget_destroy(resi);
		}
	}while(!croplock);
	// exit ok
	if(croplock==1)
	{
		*w=iw;	
		*w2=iw2;	
		*h=ih;		
		*h2=ih2;		
		return 1;
	}
  return 0;
}
//
//        Check entered values and green-out the selected portion on the screen
//        Each value must be even
//
void gui_update(GtkButton * button, gpointer user_data)
{
UNUSED_ARG(button);
UNUSED_ARG(user_data);

gchar   *str;
char string [500];
uint32_t left,right,top,bottom;
int ret;
		memcpy(globalvideo,globalsource,globalw*globalh*3);

		      GET_(left,entry_x);
		      GET_(top,entryy);
		      GET_(right,entry_x2);
		      GET_(bottom,entry_y2);

#define OODD(x) if(x&1) x--;
	
						OODD(left);
						OODD(top);
						OODD(right);
						OODD(bottom);

             SET_(left,entry_x);
		      SET_(top,entryy);
		      SET_(right,entry_x2);
		      SET_(bottom,entry_y2);

				if( (left+right) > globalw) return;
				if( (top+bottom) > globalh) return;

	// black out top & bottom
			uint8_t *ptr,*ptr2;
			uint32_t x,y;

				ptr=globalvideo;
				for( y=top;y>0;y--)
							for(  x=globalw;x>0;x--)
									{
                                 		*ptr++=0;
							        		*ptr++=255;
							        		*ptr++=0;
							
									}
				ptr=globalvideo+3*globalw*(globalh-bottom);
				for( y=bottom;y>0;y--)
							for(  x=globalw;x>0;x--)
									{
                                 		*ptr++=0;
							        		*ptr++=255;
							        		*ptr++=0;
							
									}

				ptr=globalvideo;
				for( y=globalh;y>0;y--)
					{
							ptr2=ptr+globalw*3-3*right;
							for(  x=left;x>0;x--)
									{
                                 		*(ptr+x*3)=0;
							        		*(ptr+x*3+1)=255;
							        		*(ptr+x*3+2)=0;							
									}
							for(  x=right;x>0;x--)
									{
                                       *(ptr2+x*3)=0;
							        		*(ptr2+x*3+1)=255;
							        		*(ptr2+x*3+2)=0;	
									}
						ptr+=3*globalw;
					}


	 	GUI_RGBDisplay(globalvideo, globalw,globalh,( void *)drawingarea9);


}
void gui_ko(GtkButton * button, gpointer user_data)
{
        UNUSED_ARG(button);
	    UNUSED_ARG(user_data);
	    
		if (!croplock)
    		croplock = -1;
}

gboolean  gui_draw(GtkWidget * widget,
			     GdkEventExpose * event, gpointer user_data)
{
        UNUSED_ARG(widget);
	    UNUSED_ARG(event);
	    UNUSED_ARG(user_data);
	    
	 	GUI_RGBDisplay(globalvideo, globalw,globalh,( void *)drawingarea9);
    	return true;
}

void gui_ok(GtkButton * button, gpointer user_data)
{
    UNUSED_ARG(button);
    
    int res;

    res = (int) user_data;
    if (croplock)
			return;			// second call back->ignore.
			
    switch (res)
      {
      case 1:
	  croplock = 1;
	  break;
      case 0:
	  croplock = -2;
	  break;
      }
    return;

};
GtkWidget *create_dialog4 (void)
{
  GtkWidget *dialog4;
  GtkWidget *vbox7;
  GtkWidget *vbox8;
  GtkWidget *hbox7;
  GtkWidget *vbox9;
  GtkWidget *label7;
  GtkWidget *vbox10;
  GtkWidget *label8;
  GtkWidget *hseparator3;
  GtkWidget *hbox8;
  GtkWidget *vbox11;
  GtkWidget *label9;
  GtkWidget *vbox12;
  GtkWidget *label10;
  GtkWidget *hseparator4;
  GtkWidget *hseparator5;
  GtkWidget *hbox5;
  GtkWidget *hbox6;
  GtkWidget *button_ok;
  GtkWidget *button_ko;
	GtkWidget *update;
		GtkWidget *autocrop;

/*
  GtkWidget *drawingarea9;

  GtkWidget *entry_x;
  GtkWidget *entry_y2;
  GtkWidget *entry_x2;
  GtkWidget *entryy;
*/



  dialog4 = gtk_dialog_new ();
      gtk_object_set_data_full(GTK_OBJECT(dialog4),
			     "dialog4",
			     dialog4,
			     (GtkDestroyNotify) gui_ko);

//  gtk_object_set_data (GTK_OBJECT (dialog4), "dialog4", dialog4);


  gtk_window_set_title (GTK_WINDOW (dialog4), "Crop");
  gtk_window_set_policy (GTK_WINDOW (dialog4), TRUE, TRUE, FALSE);
    gtk_window_set_modal(GTK_WINDOW(dialog4),TRUE);

  vbox7 = GTK_DIALOG (dialog4)->vbox;
  gtk_object_set_data (GTK_OBJECT (dialog4), "vbox7", vbox7);
  gtk_widget_show (vbox7);

  vbox8 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox8);
  gtk_object_set_data_full (GTK_OBJECT (dialog4), "vbox8", vbox8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox8);
  gtk_box_pack_start (GTK_BOX (vbox7), vbox8, TRUE, TRUE, 0);

  hbox7 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox7);
  gtk_object_set_data_full (GTK_OBJECT (dialog4), "hbox7", hbox7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox7);
  gtk_box_pack_start (GTK_BOX (vbox8), hbox7, TRUE, TRUE, 0);

  vbox9 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox9);
  gtk_object_set_data_full (GTK_OBJECT (dialog4), "vbox9", vbox9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox9);
  gtk_box_pack_start (GTK_BOX (hbox7), vbox9, TRUE, TRUE, 0);

  label7 = gtk_label_new ("Crop Left");
  gtk_widget_ref (label7);
  gtk_object_set_data_full (GTK_OBJECT (dialog4), "label7", label7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label7);
  gtk_box_pack_start (GTK_BOX (vbox9), label7, FALSE, FALSE, 0);

  entry_x = gtk_entry_new ();
  gtk_widget_ref (entry_x);
  gtk_object_set_data_full (GTK_OBJECT (dialog4), "entry_x", entry_x,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_x);
  gtk_box_pack_start (GTK_BOX (vbox9), entry_x, FALSE, FALSE, 0);

  vbox10 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox10);
  gtk_object_set_data_full (GTK_OBJECT (dialog4), "vbox10", vbox10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox10);
  gtk_box_pack_start (GTK_BOX (hbox7), vbox10, TRUE, TRUE, 0);

  label8 = gtk_label_new ("Crop Right");
  gtk_widget_ref (label8);
  gtk_object_set_data_full (GTK_OBJECT (dialog4), "label8", label8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label8);
  gtk_box_pack_start (GTK_BOX (vbox10), label8, FALSE, FALSE, 0);

  entry_x2 = gtk_entry_new ();
  gtk_widget_ref (entry_x2);
  gtk_object_set_data_full (GTK_OBJECT (dialog4), "entry_x2", entry_x2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_x2);
  gtk_box_pack_start (GTK_BOX (vbox10), entry_x2, FALSE, FALSE, 0);

  hseparator3 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator3);
  gtk_object_set_data_full (GTK_OBJECT (dialog4), "hseparator3", hseparator3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator3);
  gtk_box_pack_start (GTK_BOX (vbox8), hseparator3, TRUE, TRUE, 0);

  hbox8 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox8);
  gtk_object_set_data_full (GTK_OBJECT (dialog4), "hbox8", hbox8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox8);
  gtk_box_pack_start (GTK_BOX (vbox8), hbox8, TRUE, TRUE, 0);

  vbox11 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox11);
  gtk_object_set_data_full (GTK_OBJECT (dialog4), "vbox11", vbox11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox11);
  gtk_box_pack_start (GTK_BOX (hbox8), vbox11, TRUE, TRUE, 0);

  label9 = gtk_label_new ("Crop Top");
  gtk_widget_ref (label9);
  gtk_object_set_data_full (GTK_OBJECT (dialog4), "label9", label9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label9);
  gtk_box_pack_start (GTK_BOX (vbox11), label9, FALSE, FALSE, 0);

  entryy = gtk_entry_new ();
  gtk_widget_ref (entryy);
  gtk_object_set_data_full (GTK_OBJECT (dialog4), "entryy", entryy,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entryy);
  gtk_box_pack_start (GTK_BOX (vbox11), entryy, FALSE, FALSE, 0);

  vbox12 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox12);
  gtk_object_set_data_full (GTK_OBJECT (dialog4), "vbox12", vbox12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox12);
  gtk_box_pack_start (GTK_BOX (hbox8), vbox12, TRUE, TRUE, 0);

  label10 = gtk_label_new ("  Crop Bottom");
  gtk_widget_ref (label10);
  gtk_object_set_data_full (GTK_OBJECT (dialog4), "label10", label10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label10);
  gtk_box_pack_start (GTK_BOX (vbox12), label10, FALSE, FALSE, 0);

  entry_y2 = gtk_entry_new ();
  gtk_widget_ref (entry_y2);
  gtk_object_set_data_full (GTK_OBJECT (dialog4), "entry_y2", entry_y2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_y2);
  gtk_box_pack_start (GTK_BOX (vbox12), entry_y2, FALSE, FALSE, 0);

  hseparator4 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator4);
  gtk_object_set_data_full (GTK_OBJECT (dialog4), "hseparator4", hseparator4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator4);
  gtk_box_pack_start (GTK_BOX (vbox8), hseparator4, TRUE, TRUE, 0);

  hseparator5 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator5);
  gtk_object_set_data_full (GTK_OBJECT (dialog4), "hseparator5", hseparator5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator5);
  gtk_box_pack_start (GTK_BOX (vbox8), hseparator5, FALSE, FALSE, 0);

  drawingarea9 = gtk_drawing_area_new ();
  gtk_widget_ref (drawingarea9);
  gtk_object_set_data_full (GTK_OBJECT (dialog4), "drawingarea9", drawingarea9,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_set_usize(drawingarea9, 352, 288);

  gtk_widget_show (drawingarea9);
  gtk_box_pack_start (GTK_BOX (vbox7), drawingarea9, TRUE, TRUE, 0);

  hbox5 = GTK_DIALOG (dialog4)->action_area;
  gtk_object_set_data (GTK_OBJECT (dialog4), "hbox5", hbox5);
  gtk_widget_show (hbox5);
  gtk_container_set_border_width (GTK_CONTAINER (hbox5), 10);

  hbox6 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox6);
  gtk_object_set_data_full (GTK_OBJECT (dialog4), "hbox6", hbox6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox6);
  gtk_box_pack_start (GTK_BOX (hbox5), hbox6, FALSE, FALSE, 0);

  button_ok = gtk_button_new_with_label ("Ok");
  gtk_widget_ref (button_ok);
  gtk_object_set_data_full (GTK_OBJECT (dialog4), "button_ok", button_ok,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_ok);
  gtk_box_pack_start (GTK_BOX (hbox6), button_ok, FALSE, FALSE, 0);

  button_ko = gtk_button_new_with_label ("Cancel");
  gtk_widget_ref (button_ko);
  gtk_object_set_data_full (GTK_OBJECT (dialog4), "button_ko", button_ko,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_ko);
  gtk_box_pack_start (GTK_BOX (hbox6), button_ko, FALSE, FALSE, 0);

  update = gtk_button_new_with_label (" Update");
  gtk_widget_ref (update);
  gtk_object_set_data_full (GTK_OBJECT (dialog4), "update", update,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (update);
  gtk_box_pack_start (GTK_BOX (hbox6), update, FALSE, FALSE, 0);
  
   autocrop = gtk_button_new_with_label (" AutoCrop");
  gtk_widget_ref (autocrop);
  gtk_object_set_data_full (GTK_OBJECT (dialog4), "autocrop", autocrop,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (autocrop);
  gtk_box_pack_start (GTK_BOX (hbox6), autocrop, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (button_ok), "clicked",
                      GTK_SIGNAL_FUNC (gui_ok),
                      (void *)1);
  gtk_signal_connect (GTK_OBJECT (button_ko), "clicked",
                      GTK_SIGNAL_FUNC (gui_ok),
                      (void *)0);

  gtk_signal_connect (GTK_OBJECT (update), "clicked",
                      GTK_SIGNAL_FUNC (gui_update),
                      NULL);
	 gtk_signal_connect (GTK_OBJECT (autocrop), "clicked",
                      GTK_SIGNAL_FUNC (gui_autocrop),
                      NULL);
                      
   gtk_signal_connect(GTK_OBJECT(drawingarea9), "expose_event",
		       GTK_SIGNAL_FUNC(gui_draw),
		       NULL);


  return dialog4;
}
#define THRESH 150
void gui_autocrop(GtkButton * button, gpointer user_data)
{
UNUSED_ARG(button);
UNUSED_ARG(user_data);

uint8_t *ptr;
uint32_t thresh=0;
uint32_t atom=0;
uint32_t y;
char 	string[50];
int 	ret;
		
		ptr=globalsource;
		
		// Search top
		for( y=0;y<globalh>>1;y++)
		{
           for(uint32_t x=0;x<globalw;x++)
           {
						 atom=(*ptr * *ptr)+(*(ptr+1) * *(ptr+1))+(*(ptr+2) * *(ptr+2));
						 ptr+=3;
						 if(atom>THRESH) thresh+=1;
						 if(thresh>10) goto fond;						 
			}												
		}		
fond:
				
				y+=2;
				if(y+6>(globalh>>1)) return ;
				OODD(y);
    	      SET_(y,entryy);
           // now bottom
           //_________________________
            	ptr=globalsource+globalw*(globalh-1)*3;
             uint8_t *start=ptr;
		
		thresh=0;
		// Search top
		for( y=0;y<globalh>>1;y++)
		{
			ptr=start;
			start-=3*globalw;
           for(uint32_t x=0;x<globalw;x++)
           {
						 atom=(*ptr * *ptr)+(*(ptr+1) * *(ptr+1))+(*(ptr+2) * *(ptr+2));
						 ptr+=3;
						 if(atom>THRESH) thresh+=1;
						 if(thresh>10) goto fond2;						 
			}												
		}		
fond2:		
				 y+=2;
				OODD(y);
    	      SET_(y,entry_y2);
           
		      gui_update(NULL,NULL);

}


#endif
