/***************************************************************************
                          ADM_guiDenoise.cpp  -  description
                             -------------------
    begin                : Tue Nov 26 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
  /*
 * DO NOT EDIT THIS FILE - it is generated by Glade.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include <assert.h>

#include "fourcc.h"
#include "avio.hxx"
#include "config.h"
#include "avi_vars.h"
#ifdef HAVE_ENCODER


#include "ADM_editor/ADM_edit.hxx"
#include "ADM_video/ADM_genvideo.hxx"
#include "ADM_video/ADM_vidDenoise.h"

static 	GtkObject *spin_llock_adj;
static  GtkWidget *spin_llock;
static  GtkObject *spin_lthresh_adj;
static  GtkWidget *spin_lthresh;
static  GtkObject *spin_clock_adj;
static  GtkWidget *spin_clock;
static  GtkObject *spin_cthresh_adj;
static  GtkWidget *spin_cthresh;
static  GtkObject *spin_schange_adj;
static  GtkWidget *spin_schange;

static int compresslock;

static int getDenoiseParams(
                            int *llock,int *lthresh,
                            int *clock,int *cthresh,
                            int *cchange
														);


static void gui_del(GtkButton * button, gpointer user_data);														
static void gui_ok(GtkButton * button, gpointer user_data)	;
static GtkWidget *create_dialog1 (void);
extern void runDialog(volatile int *to);																										

void *ADMVideoDenoise::configure(AVDMGenericVideoStream * instream)
{
  UNUSED_ARG(instream);
  int ll,lt,cl,ct,sc;
  
  ll=_param->lumaLock;
  lt=_param->lumaThreshold;
  cl=_param->chromaLock;
  ct=_param->chromaThreshold;
  sc=_param->sceneChange;
    
    if (getDenoiseParams(	&ll,
    												&lt, 
                          	&cl,
    												&ct, 
    												&sc
               						)  )
      {
			_param->lumaLock=ll;
		  _param->lumaThreshold=lt;
		  _param->chromaLock=cl;
		  _param->chromaThreshold=ct;
		  _param->sceneChange=sc;	
		  _lastFrame=0xfffffff0;	
		  printf("\n ll: %d lt:%d cl: %d ct : %d sc:%d\n",
		  						ll,lt,cl,ct,sc);
				  return (void *) _param;
      }
   
    	return NULL;
}
																										

int getDenoiseParams(
                            int *llock,int *lthresh,
                            int *clock,int *cthresh,
                            int *cchange
														)
{
    static GtkWidget *cprm;
    //char *str;
    //char string[100];
    //uint32_t value;
    //int ret = 0;

	
	  compresslock = 0;
	  cprm = create_dialog1();
	  // update values
	#define CHECKSPIN(x,y)  gtk_spin_button_set_value(GTK_SPIN_BUTTON(x),(float)y) ;
          			CHECKSPIN( spin_llock,*llock);
          			CHECKSPIN( spin_clock,*clock);
          			CHECKSPIN( spin_lthresh,*lthresh);
          			CHECKSPIN( spin_cthresh,*cthresh);
          			CHECKSPIN( spin_schange,*cchange);
             
                         												
		#undef CHECKSPIN
	
	  	  
	  gtk_widget_show(cprm);
	  
	  runDialog(&compresslock);
	
	  if(compresslock==1)
	  {  
	 
						
		#define CHECKSPIN(x,y) y= gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(x)) ;
          			CHECKSPIN( spin_llock,*llock);
          			CHECKSPIN( spin_clock,*clock);
          			CHECKSPIN( spin_lthresh,*lthresh);
          			CHECKSPIN( spin_cthresh,*cthresh);
          			CHECKSPIN( spin_schange,*cchange);												
		#undef CHECKSPIN
		gtk_widget_destroy(cprm);
		printf("\n OK\n");
		return 1;
	}
    if(compresslock!=-2) gtk_widget_destroy(cprm);

		printf("\n KO\n");

    return 0;

}

void gui_del(GtkButton * button, gpointer user_data)
{
    UNUSED_ARG(button);
    UNUSED_ARG(user_data);
    gui_ok(NULL, (gpointer) -1);
}


void gui_ok(GtkButton * button, gpointer user_data)
{
    UNUSED_ARG(button);
    int res;

    res = (int) user_data;
    if (compresslock)
					return;			// second call back->ignore.
    switch (res)
      {
      case 1:
				  compresslock = 1;	  
				  break;
      case 0:
				  compresslock = -1;
				  break;
      case -1:
     			compresslock=-2;
	      	break;
       default:
       		assert(0);
      }
    return;

};


GtkWidget *create_dialog1 (void)
{
  GtkWidget *dialog1;
  GtkWidget *dialog_vbox1;
  GtkWidget *table1;
  GtkWidget *label1;
  GtkWidget *label2;
  GtkWidget *label3;
  GtkWidget *label4;
/*  
GtkObject *spin_llock_adj;
  GtkWidget *spin_llock;
  GtkObject *spin_lthresh_adj;
  GtkWidget *spin_lthresh;
  GtkObject *spin_clock_adj;
  GtkWidget *spin_clock;
  GtkObject *spin_cthresh_adj;
  GtkWidget *spin_cthresh;
  GtkObject *spin_schange_adj;
  GtkWidget *spin_schange;
  */
  GtkWidget *label5;
  
  GtkWidget *dialog_action_area1;
  GtkWidget *hbox1;
  GtkWidget *button_ok;
  GtkWidget *button_ko;

  dialog1 = gtk_dialog_new ();
//  gtk_object_set_data (GTK_OBJECT (dialog1), "dialog1", dialog1);

 gtk_object_set_data_full(GTK_OBJECT(dialog1),
			     "dialog1",
			     dialog1,
			     (GtkDestroyNotify) gui_del);

  gtk_window_set_title (GTK_WINDOW (dialog1), ("Denoise paramaters"));
  gtk_window_set_policy (GTK_WINDOW (dialog1), TRUE, TRUE, FALSE);

  dialog_vbox1 = GTK_DIALOG (dialog1)->vbox;
  gtk_object_set_data (GTK_OBJECT (dialog1), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  table1 = gtk_table_new (5, 2, FALSE);
  gtk_widget_ref (table1);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "table1", table1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), table1, TRUE, TRUE, 0);

  label1 = gtk_label_new (("Luma lock"));
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_table_attach (GTK_TABLE (table1), label1, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label1), 0, 0.5);

  label2 = gtk_label_new (("Luma Threshold"));
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtk_table_attach (GTK_TABLE (table1), label2, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label2), 0, 0.5);

  label3 = gtk_label_new (("Chroma Lock"));
  gtk_widget_ref (label3);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "label3", label3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label3);
  gtk_table_attach (GTK_TABLE (table1), label3, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label3), 0, 0.5);

  label4 = gtk_label_new (("Chroma Threshold"));
  gtk_widget_ref (label4);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "label4", label4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label4);
  gtk_table_attach (GTK_TABLE (table1), label4, 0, 1, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (label4, 130, -2);
  gtk_misc_set_alignment (GTK_MISC (label4), 0, 0.5);

  spin_llock_adj = gtk_adjustment_new (4, 1, 255, 1, 10, 10);
  spin_llock = gtk_spin_button_new (GTK_ADJUSTMENT (spin_llock_adj), 1, 0);
  gtk_widget_ref (spin_llock);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "spin_llock", spin_llock,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spin_llock);
  gtk_table_attach (GTK_TABLE (table1), spin_llock, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spin_llock), TRUE);

  spin_lthresh_adj = gtk_adjustment_new (8, 1, 256, 1, 10, 10);
  spin_lthresh = gtk_spin_button_new (GTK_ADJUSTMENT (spin_lthresh_adj), 1, 0);
  gtk_widget_ref (spin_lthresh);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "spin_lthresh", spin_lthresh,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spin_lthresh);
  gtk_table_attach (GTK_TABLE (table1), spin_lthresh, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spin_lthresh), TRUE);

  spin_clock_adj = gtk_adjustment_new (10, 1, 256, 1, 10, 10);
  spin_clock = gtk_spin_button_new (GTK_ADJUSTMENT (spin_clock_adj), 1, 0);
  gtk_widget_ref (spin_clock);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "spin_clock", spin_clock,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spin_clock);
  gtk_table_attach (GTK_TABLE (table1), spin_clock, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spin_clock), TRUE);

  spin_cthresh_adj = gtk_adjustment_new (16, 1, 256, 1, 10, 10);
  spin_cthresh = gtk_spin_button_new (GTK_ADJUSTMENT (spin_cthresh_adj), 1, 0);
  gtk_widget_ref (spin_cthresh);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "spin_cthresh", spin_cthresh,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spin_cthresh);
  gtk_table_attach (GTK_TABLE (table1), spin_cthresh, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spin_cthresh), TRUE);

  label5 = gtk_label_new (("Scene Change"));
  gtk_widget_ref (label5);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "label5", label5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label5);
  gtk_table_attach (GTK_TABLE (table1), label5, 0, 1, 4, 5,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label5), 0, 0.5);

  spin_schange_adj = gtk_adjustment_new (1, 1, 255, 1, 10, 10);
  spin_schange = gtk_spin_button_new (GTK_ADJUSTMENT (spin_schange_adj), 1, 0);
  gtk_widget_ref (spin_schange);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "spin_schange", spin_schange,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spin_schange);
  gtk_table_attach (GTK_TABLE (table1), spin_schange, 1, 2, 4, 5,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spin_schange), TRUE);

  dialog_action_area1 = GTK_DIALOG (dialog1)->action_area;
  gtk_object_set_data (GTK_OBJECT (dialog1), "dialog_action_area1", dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area1), 10);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), hbox1, TRUE, TRUE, 0);

  button_ok = gtk_button_new_with_label (("OK"));
  gtk_widget_ref (button_ok);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "button_ok", button_ok,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_ok);
  gtk_box_pack_start (GTK_BOX (hbox1), button_ok, FALSE, FALSE, 0);

  button_ko = gtk_button_new_with_label (("cancel"));
  gtk_widget_ref (button_ko);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "button_ko", button_ko,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_ko);
  gtk_box_pack_start (GTK_BOX (hbox1), button_ko, FALSE, FALSE, 0);

   gtk_signal_connect (GTK_OBJECT (button_ok), "clicked",
                      GTK_SIGNAL_FUNC (gui_ok),
                      (void *)1);
  gtk_signal_connect (GTK_OBJECT (button_ko), "clicked",
                      GTK_SIGNAL_FUNC (gui_ok),
                      (void *)0);
  
  return dialog1;
}

#endif
