/***************************************************************************
                          ADM_vidDropOut.cpp  -  description
                             -------------------
    begin                : Mon Oct 7 2002
    copyright            : (C) 2002 by Ron Reithoffer 
    email                : <ron.reithoffer@chello.at>
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <assert.h>
#include <math.h>


#include "fourcc.h"
#include "avio.hxx"
#include "config.h"
#include "avi_vars.h"
#ifdef HAVE_ENCODER


#include "ADM_toolkit/toolkit.hxx"
#include "ADM_editor/ADM_edit.hxx"
#include "ADM_video/ADM_genvideo.hxx"
#include "ADM_video/ADM_vidDropOut.h"

//extern uint8_t distMatrix[256][256];
static uint32_t fixMul[16];

//_______________________________________________________________
 AVDMGenericVideoStream *dropout_create(AVDMGenericVideoStream *in, void *param)

{
		for(int i=1;i<16;i++)
			{
					fixMul[i]=(1<<16)/i;
			}
		return new     ADMVideoDropOut(in,param);
}

 char 								*ADMVideoDropOut::printConf(void)
 {
	  	static char buf[50];
 	
 				sprintf((char *)buf," DropOut :%ld",*_param);
        return buf;
	}
uint8_t  GUI_getIntegerValue(int *valye, int min, int max, char *title);	
void	*ADMVideoDropOut::configure(AVDMGenericVideoStream *instream)
{
int i;
			_in=instream;
			i=(int)*_param;
			if(GUI_getIntegerValue(&i,1,255,"DropOut Threshold"))
			{
					*_param=(uint32_t)i;
			}
			return (void *)_param;
		    
	
}
//--------------------------------------------------------	
ADMVideoDropOut::ADMVideoDropOut(
									AVDMGenericVideoStream *in,void *setup)
                  :ADMVideoCached(in,setup)
{
  //uint32_t frame;
  _uncompressed=NULL;
   
 
  _info.encoding=1;
  if(setup)
  {
			_param=(uint32_t *)setup;
	}
	else
	{
			_param=new uint32_t;
			*_param=30;
	}
 
}


//                     1
//		Get in range in 121 + coeff matrix
//                     1
//
// If the value is too far away we ignore it
// else we blend

uint8_t ADMVideoDropOut::getFrameNumberNoAlloc(uint32_t frame,
																	uint32_t *len,
   																	uint8_t *data,
   																	uint32_t *flags)
{
UNUSED_ARG(flags);

uint32_t uvlen;
uint32_t dlen,dflags;

uint8_t										*_next;
uint8_t										*_previous;  	
uint8_t										*_current;
	//		printf("\n DropOut : %lu\n",frame);

		
					
			
			uvlen=    _info.width*_info.height;
			*len=uvlen+(uvlen>>1);
		  if(frame> _info.nb_frames-1) return 0;
			if(!frame || (frame==_info.nb_frames-1))
			{
				 if(!_in->getFrameNumberNoAlloc(frame, &dlen,_buffer[0],&dflags))
				 {
					 	return 0;
					}
				 _bufnum[0]=frame;
					memcpy(data,_buffer[0],*len);
					return 1;
			}	 
				assert(frame<_info.nb_frames);   
			// read uncompressed frame
			switch(fillCache(frame))
			{
				  case 0: return 0;
				  case 1: memcpy(data,_buffer[index_c],*len);return 1;break;
				  case 2: break;
				  default: assert(0); break;				
			}
   		_previous=_buffer[index_p];		
   		_current=_buffer[index_c];
   		_next=_buffer[index_n];          
           // for u & v , no action -> copy it as is
           memcpy(data+uvlen,_current+uvlen,uvlen>>1);
               							   				
             uint8_t *inprev,*innext,*incur,*zout;

              inprev=_previous+1+_info.width;
              innext=_next+1+_info.width;
              incur =_current+1+_info.width;

              zout=data+_info.width+1;

              //uint16_t _thres=30;



              //uint16_t c,coeff;
              int32_t c0,c1,c2,c3; //,_nextPix,_currPix,_prevPix,cc;




              for(uint32_t y= _info.height-2;y>2;y--)


              //for(uint32_t y= _info.height-1;y>1;y--)
              	{



		  c0=0;
		  c1=0;
		  c2=0;
		  c3=0;


					    for(uint32_t x= _info.width-1;x>1;x--)
        			      	{



						c0+=(abs(((*inprev))-( *incur    ))^2);
						c1+=(abs(((*inprev))-( *innext   ))^2)<<1;
						c0+=(abs(((*incur ))-( *innext   ))^2);

//						c2+=(abs(((    *(incur-_info.width) ))-( *(incur            )   ))^2)   ;
//						c3+=(abs(((    *(incur-_info.width) ))-( *(incur+_info.width)   ))^2)<<1;
//						c2+=(abs(((    *(incur            ) ))-( *(incur+_info.width)   ))^2)   ;

						c2+=(abs(((    *(incur-_info.width*2) ))-( *(incur            )   ))^2)   ;
						c3+=(abs(((    *(incur-_info.width*2) ))-( *(incur+_info.width*2)   ))^2)<<1;
						c2+=(abs(((    *(incur            ) ))-( *(incur+_info.width*2)   ))^2)   ;




													zout++;
													incur++;
													innext++;
													inprev++;
											}


											zout+=2;
											incur+=2;
											innext+=2;
											inprev+=2;


											zout-=_info.width;
											incur-=_info.width;
											innext-=_info.width;
											inprev-=_info.width;




					    for(uint32_t x= _info.width-1;x>1;x--)
        			      	{


      						*zout=*incur;



						if (c1<c0) { if (c3<c2) {*zout= (*(inprev))+(*(innext))>>1 ;}}

													zout++;
													incur++;
													innext++;
													inprev++;
											}

											zout+=2;
											incur+=2;
											innext+=2;
											inprev+=2;
								}



							return 1;






}
ADMVideoDropOut::~ADMVideoDropOut()
{


}


#endif
