/***************************************************************************
                          ADM_vidNull.cpp  -  description
                             -------------------

    This filter takes format xxx as input and output uncompressed video

    begin                : Wed Mar 20 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include "fourcc.h"
#include "avio.hxx"
#include "config.h"
#include "ADM_editor/ADM_edit.hxx"
#include "assert.h"
#include "ADM_video/ADM_genvideo.hxx"

extern uint8_t *rdr_decomp_buffer;
uint8_t GUI_Render_NoDisplay(uint8_t * ptr, uint32_t len);

//_______________________________________________________________

AVDMVideoStreamNull::AVDMVideoStreamNull(ADM_Composer *in)
{
aviInfo aviinf;
  	_in=in;	
  	
  	// now build infos
  	
  	assert(_in->getVideoInfo(&aviinf));
  	_info.width=aviinf.width;
  	_info.height=aviinf.height;
  	_info.nb_frames=aviinf.nb_frames;
  	_info.encoding=0;
	_info.fps1000=aviinf.fps1000;
  	_uncompressed=(uint8_t *)malloc(3*aviinf.width*aviinf.height);
  	assert(_uncompressed);
  	
  	
}
AVDMVideoStreamNull::~AVDMVideoStreamNull()
{

 	free(_uncompressed);
}
//
//	Basically ask a uncompressed frame from editor and ask
//		GUI to decompress it .
//

uint8_t AVDMVideoStreamNull::getFrameNumberNoAlloc(uint32_t frame, uint32_t *len,
   																	uint8_t *data,uint32_t *flags)
{
        UNUSED_ARG(len);
    	UNUSED_ARG(flags);
		if(!(frame<_info.nb_frames))
		{
				printf("\n goiing out of bounds! :%ld / %ld \n",frame,_info.nb_frames);
				return 0;
		}
		
			// read uncompressed frame

    	if(!_in->getUncompressedFrame(frame,data)     )
     			return 0;
        return 1;


}
