/***************************************************************************
                          ADM_vidpreview.cpp  -  description
                             -------------------

       Previewer, we switch to RGB (only one Xv at a time)   and display the incoming
       YV12 buffer in a nice windowd

    begin                : Mon Mar 25 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

#include <gtk/gtk.h>
#include <time.h>
#include <sys/time.h>
#include <assert.h>

#include "fourcc.h"
#include "avio.hxx"
#include "config.h"
#include "avi_vars.h"
#ifdef HAVE_ENCODER
extern void yv12rgb(uint8_t * ptr, uint8_t * ptr2, uint32_t w, uint32_t h);

static void 					previewRender(void);
static void 					preview_exit(GtkButton * button, gpointer user_data);
static GtkWidget    *creat_dialog2 (void);
static gboolean 		preview_exit_short (GtkWidget * widget,GdkEvent * event, gpointer user_data);

static uint8_t *rgb_render=NULL;
static GtkWidget *drawingarea_preview;
static GtkWidget *dialog;
static uint32_t uw, uh;
int lock;
extern void 		setPreviewToggleStatus( uint8_t i);
extern void yuv420_argb32_mmx (uint8_t * image, uint8_t * py,
			       uint8_t * pu, uint8_t * pv,
			       int h_size, int v_size);

// Init previewer
//
uint8_t GUI_StillAlive( void )
{
 	if(dialog==NULL) return 0;
  	return 1;

}
void GUI_PreviewInit(uint32_t w , uint32_t h)
{
		if(rgb_render)
		{
			printf("\n Warning rgb render not null...\n");
			free(rgb_render);
		}
      assert(rgb_render=(uint8_t *)malloc(w*h*3));
       uw=w;
       uh=h;
       //
          dialog=creat_dialog2();
       gtk_widget_set_usize (drawingarea_preview,w,h);
       //
       lock=0;
       gtk_widget_show(  dialog);
}
// return 1 if preview is still running
uint8_t  GUI_PreviewUpdate(uint8_t *data)
{
		
	
		// First convert YV12 to RGB
       if(  dialog)
       {

	       yv12rgb(data, rgb_render ,  uw, uh);
	       previewRender();
	       gtk_widget_show(  dialog);	
	    	if(lock==1)
	    	{
	    		gtk_widget_destroy( dialog);
	    		dialog=NULL;
	    		return 0;
	    	}
	    	else
	    		return 1;
	    }
	    return 0;

}
void GUI_PreviewEnd(void)
{
 	if(dialog)
 		{
 		 	gtk_widget_destroy(dialog);
 		 	dialog=NULL;
 		}
 	if(rgb_render)
 		{
 		 	free(rgb_render);
 		 	rgb_render=NULL;
 		}

}
void previewRender(void)
{
   gdk_draw_rgb_image(drawingarea_preview->window,
         								drawingarea_preview->style->fg_gc[GTK_STATE_NORMAL], 0,	// X
								       0,	// y
								       uw,	//width
								       uh,	//h*2, // heigth
								       GDK_RGB_DITHER_NONE,
								       (guchar *) rgb_render,	// buffer
								       uw * 3);
}
// Called when the exit button is pushed
//
void preview_exit(GtkButton * button, gpointer user_data)
{
    UNUSED_ARG(button);
    UNUSED_ARG(user_data);
//	uint32_t i;
 		  GUI_PreviewEnd();
     		if(lock==0)
       	{
		    	lock=-1;
            		setPreviewToggleStatus( 0);	

       	}
	
	
}
// Called when window is destroyed
gboolean preview_exit_short (GtkWidget * widget, GdkEvent * event, gpointer user_data)
{
    UNUSED_ARG(widget);
    UNUSED_ARG(event);
	UNUSED_ARG(user_data);
	
	GUI_PreviewEnd();
    if(lock==0)
    {
	    lock=-1;
       	setPreviewToggleStatus( 0);	
    }
	return 0;
}

 //_______________________________
GtkWidget  *creat_dialog2 (void)
{
  GtkWidget *dialog2;
  GtkWidget *dialog_vbox2;
  //GtkWidget *drawingarea_preview;
  GtkWidget *dialog_action_area2;
  GtkWidget *button4;

  dialog2 = gtk_dialog_new ();
  //gtk_object_set_data (GTK_OBJECT (dialog2), "dialog2", dialog2);

    gtk_object_set_data_full(GTK_OBJECT(dialog2),
			     "dialog2",
			     dialog2,
			     (GtkDestroyNotify) preview_exit_short);

  gtk_window_set_title (GTK_WINDOW (dialog2), "Preview");
  gtk_window_set_policy (GTK_WINDOW (dialog2), TRUE, TRUE, FALSE);

  dialog_vbox2 = GTK_DIALOG (dialog2)->vbox;
  gtk_object_set_data (GTK_OBJECT (dialog2), "dialog_vbox2", dialog_vbox2);
  gtk_widget_show (dialog_vbox2);

  drawingarea_preview = gtk_drawing_area_new ();
  gtk_widget_ref (drawingarea_preview);
  gtk_object_set_data_full (GTK_OBJECT (dialog2), "drawingarea_preview", drawingarea_preview,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (drawingarea_preview);
  gtk_box_pack_start (GTK_BOX (dialog_vbox2), drawingarea_preview, TRUE, TRUE, 0);

  dialog_action_area2 = GTK_DIALOG (dialog2)->action_area;
  gtk_object_set_data (GTK_OBJECT (dialog2), "dialog_action_area2", dialog_action_area2);
  gtk_widget_show (dialog_action_area2);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area2), 10);

  button4 = gtk_button_new_with_label ("Dismiss");
  gtk_widget_ref (button4);
  gtk_object_set_data_full (GTK_OBJECT (dialog2), "button4", button4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button4);
  gtk_box_pack_start (GTK_BOX (dialog_action_area2), button4, FALSE, FALSE, 0);

    gtk_signal_connect(GTK_OBJECT(button4), "clicked",
		       GTK_SIGNAL_FUNC(preview_exit),
		       (void *) 1);
       gtk_signal_connect(GTK_OBJECT(drawingarea_preview), "expose_event",
		       GTK_SIGNAL_FUNC(previewRender),
		       NULL);
		
  return dialog2;
}
#endif

/*
Packed
		Integer computation convert YV12 -> plain RGB
		Y 4 bits U 4 bits V 4 bits
		

   221=2097152
R = Y + 1.402V              2940207
G = Y - 0.344U - 0.714V     721420 1497366
B = Y + 1.772U              3716153
See
http://support.microsoft.com/default.aspx?scid=kb;EN-US;q294880
For format explanation
 Comprised of an NxN Y plane followed by (N/2)x(N/2) U and V planes. This format draws a top-down image (for example, the first line is at the top of the screen).

*/
#define FAC  2097152
#define RFAC 2940207
#define GFAC1 721420
#define GFAC2 1497366
#define BFAC 3716153

static uint8_t Clip[256+64+64];

uint8_t slowYV12RGB(uint8_t * ptr_y,
		    uint8_t * ptr_u,
		    uint8_t * ptr_v, uint8_t * ptr2, uint32_t w)
{

    int32_t y0, u0, v0;
    int32_t y1;
    int32_t r, g, b;
    int32_t r1, g1, b1;
    static int init=0;

    	if(init==0)
     		{
         		memset(Clip,255,256+64+64);
         		memset(Clip,0,64);
           	for(int16_t i=0;i<256;i++) Clip[i+64]=i;
              init=1;
         }
/*  	Let's do 2^21 computation   */

     if(w& 2) w-=2; // manolis bug
    while (w)
      {
        //

//#define CLIP(x) if(x<0) x=0;if(x>255) x=255;
#define CLIP(x) x=Clip[x+64]

#define MMM(y,u,v)		r1= RFAC*v; \
		g1= -GFAC1*u -GFAC2*v; \
		b1= + BFAC*u ;      \
	  r = (y +r1)>>21;    \
		g = (y +g1)>>21;    \
		b = (y +b1)>>21;    \
    CLIP(r);CLIP(g);CLIP(b); \
	*ptr2++=r;	*ptr2++=g;	*ptr2++=b;
#define MMM2(y) \
	  r = (y +r1)>>21;    \
		g = (y +g1)>>21;    \
		b = (y +b1)>>21;    \
    CLIP(r);CLIP(g);CLIP(b); \
	*ptr2++=r;	*ptr2++=g;	*ptr2++=b;

	  y0 = (*ptr_y++) <<21;
	  y1 = (*ptr_y++) <<21;

	  u0 = (*ptr_u++) - 128;
	  v0 = (*ptr_v++) - 128;
	  MMM(y0, u0, v0);
	  MMM2(y1);

	  //--------------------
	  //______________________________________
	  y0 = (*ptr_y++) <<21;
	  y1 = (*ptr_y++) <<21;
	  u0 = (*ptr_u++) - 128;
	  v0 = (*ptr_v++) - 128;
	  MMM(y0, u0, v0);
	  MMM2(y1);


//

	  w -= 4;
      }
    return 1;
}

//____________________________________________________________
// YUYV Version
//____________________________________________________________
extern void fastYV12RGB_mmx ( uint8_t * py,
			       uint8_t * pu, uint8_t * pv,  uint8_t * image,
			       int h_size);


void yv12rgb(uint8_t * ptr, uint8_t * ptr2, uint32_t w, uint32_t h)
{
    uint32_t i, l;
    uint8_t *y, *u, *v, *e;

    l = w;			// line width in byte
    y = ptr;
    v = y + w * h;
    u = v + ((w * h) >> 2);
    e = ptr2;

    for (i = (h>>1)-1; i > 0; i--)
      {
#ifdef USE_MMX
	  fastYV12RGB_mmx(y, u, v, e, w);
	  //fastYV12RGB_mmx(y+w, u, v, e+3*w, w);
#else
	  slowYV12RGB(y, u, v, e, w);
	  slowYV12RGB(y+w, u, v, e+3*w, w);
#endif

   	   y += w<<1;
		u += w >> 1;
		v += w >> 1;
	   e += 6 * w;
      }

}




