/***************************************************************************
                         callback.c, gui that interact with user 
                             -------------------
    begin                : Thu Nov 1 2001
    copyright            : (C) 2001 by mean
    email                : fixounet@free.fr

	Quick hack to have a gui.
	Not specially proud of it.  All the messy stuff should be here.

Mean.	

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <unistd.h>

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include <gdk/gdktypes.h>
#include <time.h>
#include <sys/time.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#include "fourcc.h"
#include "avi_vars.h"
#include "ADM_toolkit/filesel.h"
#include "prototype.h"
#include "ADM_audiodevice/audio_out.h"
#include "ADM_audio/aviaudio.hxx"
#include "ADM_audiofilter/audioprocess.hxx"
#include "ADM_audio/audioex.h"
#include "gui_action.hxx"
#include "gtkgui.h"
#include "gui_action.hxx"
#include "ADM_gui/GUI_vars.h"
extern void HandleAction(Action act);

//#define _PLAY_AUDIO_
//
//_________________________________

// Utilities
//__________

void frame2time(uint32_t frame, uint32_t fps, uint16_t * hh, uint16_t * mm,
		uint16_t * ss, uint16_t * ms);
//
void redraw(void);
uint8_t getRangeInMenu(GtkWidget * Menu);
//
//static GtkWidget window_wait;
static GtkWidget *wabout = NULL;
 int ignore_change = 0;

extern float GUI_readScale( void );
extern  void GUI_setScale( uint32_t val );


//static int16_t mp3lock;

//_____________________________________________________________
uint8_t stop_req = 0;



//
//      Handle numeric input from user
//                    --> unused<--
void GUI_GoToGUI(uint8_t type)
{

    // frame ?
    if (ignore_change)
      {
	  ignore_change--;
#warning FIXME
	  return;
      }
    if (type == 0)
      {
	  // read new value
	  printf("\n numeric input\n");
/*
      gtk_entry_set_text((GtkEntry *)sb_frame,text) ;
			sscanf(text,"%lu",&nf);
			if(nf<avifileinfo->nb_frames)
			{
					printf("accepted...");
       	 	curframe=nf;
					GUI_GoToFrame(curframe);
			}
*/
      }
    update_status_bar();

}

extern uint32_t getTimeOfTheDay(void);
//_____________________________________________________________
gboolean
on_drawingarea1_expose_event(GtkWidget * widget,
			     GdkEventExpose * event, gpointer user_data)
{
UNUSED_ARG(widget);
UNUSED_ARG(event);
UNUSED_ARG(user_data);
static uint32_t last_time=0;
uint32_t time=0;
    if (avifileinfo && screen_buffer)
      {
      	  //time=getTimeOfTheDay();
	  //if((time-last_time)>20)
	  	GUI_Refresh();
	  last_time=time;
      }
    return FALSE;
}


//
//_____________________________________________________________
void update_status_bar(int all)
{
    char text[80];
    char text2[80];
    double len;
    uint16_t hh, mm, ss, ms;
    int val;

    //    if(!guiReady) return ;
    text[0] = 0;
    text2[0] = 0;


    // frames 
    sprintf(text, "%lu", curframe);
    gtk_entry_set_text((GtkEntry *) sb_frame, text);
    if (all)
      {
	  sprintf(text, "/%lu", avifileinfo->nb_frames);
	  gtk_label_set_text((GtkLabel *) sb_totalframe, text);
      }
    // get time value
    text[0] = 0;
    text2[0] = 0;

    frame2time(curframe, avifileinfo->fps1000, &hh, &mm, &ss, &ms);
    sprintf(text, "%02d:%02d:%02d.%03d", hh, mm, ss, ms);
    gtk_entry_set_text((GtkEntry *) sb_time, text);
    if (all)
      {
	  frame2time(avifileinfo->nb_frames, avifileinfo->fps1000, &hh,
		     &mm, &ss, &ms);
	  sprintf(text, "/%02d:%02d:%02d.%03d", hh, mm, ss, ms);
	  gtk_label_set_text((GtkLabel *) sb_totaltime, text);


      }
    if(!ignore_change)
    {
      	ignore_change++;
    // progress bar
    len = 100;
    len=len / (double) avifileinfo->nb_frames;
    len *= (double) curframe;

    val=(int)len;

     GUI_setScale(val);
   	ignore_change--;
    }
}

// convert frame + fps1000 in time hh:mm:ss.ms
void
frame2time(uint32_t frame, uint32_t fps, uint16_t * hh, uint16_t * mm,
	   uint16_t * ss, uint16_t * ms)
{
    UNUSED_ARG(fps);
    uint32_t len2;
    len2 = video_body->getTime(frame);
    *hh = (uint32_t) floor(len2 / (3600.F * 1000.F));
    len2 -= (uint32_t) floor(*hh * 3600.F * 1000.F);
    *mm = (uint32_t) floor(len2 / (60.F * 1000.F));
    len2 -= (uint32_t) floor(*mm * 60.F * 1000.F);
    *ss = (uint32_t) floor(len2 / (1000.F));
    len2 -= (uint32_t) floor((*ss * 1000.F));
    *ms = (uint32_t) floor(len2);

}

//____________________________________________


gboolean on_window1_destroy_event(GtkWidget * widget,
				  GdkEvent * event, gpointer user_data)
{
    UNUSED_ARG(widget);
    UNUSED_ARG(event);
    UNUSED_ARG(user_data);
    HandleAction(ACT_Exit);
    return 1;
}

void guiCallback(GtkMenuItem * menuitem, gpointer user_data)
{
    UNUSED_ARG(menuitem);
    Action act;
    uint32_t aint;

    aint = (uint32_t) user_data;
    act = (Action) aint;
    HandleAction(act);
}

//
//____________________________________________

//_____________________________________________________________
//
//              Load MP3 and identify wavfmt infos to fill avi header
//              -> use mad ?
//
//_____________________________________________________________
void GUI_loadMP3(char *name)
{
    if (!avifileinfo)
	return;
    AVDMMP3AudioStream *mp3 = new AVDMMP3AudioStream();

    if (mp3->open(name) == 0)
      {
	  printf("MP3 open file failed...");
	  delete mp3;
	  return;
      }
    //currentaudiostream=mp3;
    changeAudioStream(mp3, AudioMP3);
    wavinfo = currentaudiostream->getInfo();
}


void
on_sb_scale_drag_data_received(GtkMenuItem * menuitem, gpointer user_data)
{
    UNUSED_ARG(menuitem);
    UNUSED_ARG(user_data);
    //printf("\n new value : %d",(uint16_t)GTK_ADJUSTMENT(scale_adj)->value);
    //printf("\n Slider changed\n");
    if(!ignore_change)
    {
      	ignore_change++;
	    HandleAction(ACT_Scale);
     ignore_change--;

     }

}

uint32_t GUI_GetScale(void)
{

    gfloat percent;
    float tg;

    percent = GUI_readScale();
    tg= avifileinfo->nb_frames * percent / 100.;
    
    return (uint32_t)floor(tg);;


}


// Display about box
void on_about1_activate(GtkMenuItem * menuitem, gpointer user_data)
{
    UNUSED_ARG(menuitem);
    UNUSED_ARG(user_data);
    if (wabout == NULL)
	wabout = create_aboutwindow(GTK_WIDGET(window1));
    gtk_widget_show(wabout);
};

// when clicked on about logo
void on_about_button_clicked(GtkMenuItem * menuitem, gpointer user_data)
{
    UNUSED_ARG(menuitem);
    UNUSED_ARG(user_data);
    if (wabout != NULL)
	gtk_widget_hide(wabout);
    //gtk_widget_destroy(wabout);
}

void on_sb_frame_changed(GtkMenuItem * menuitem, gpointer user_data)
{
    UNUSED_ARG(menuitem);
    UNUSED_ARG(user_data);
    HandleAction(ACT_FrameChanged);

};

void on_sb_time_changed(GtkMenuItem * menuitem, gpointer user_data)
{
    UNUSED_ARG(menuitem);
    UNUSED_ARG(user_data);
    HandleAction(ACT_TimeChanged);
};

// when keys are pressed
// We have to duplicate the ALT ... shortcut
// because of change of focus ?
void on_key_press(GtkWidget *widget, GdkEventKey* event, gpointer user_data)
{
    UNUSED_ARG(widget);
    UNUSED_ARG(user_data);
	gboolean shift = FALSE;
	gboolean ctrl = FALSE;
	gboolean alt = FALSE;
	Action action;

	if (event->state & GDK_CONTROL_MASK)
	{
		ctrl = TRUE;
	}
	if (event->state & GDK_SHIFT_MASK)
	{
		shift = TRUE;
	}
	if(event->state & GDK_MOD1_MASK)
	{
		alt = TRUE;
	}
	
	if(alt)
	{
		printf("\n Alt \n");
		switch(event->keyval)
		{
			// repeat Keyboard stuff
			case GDK_B:
			
				if(shift)
					action=ACT_GotoMarkA;
				else
					action=ACT_MarkA;
				break;
			case GDK_E:
			
				if(shift)
					action=ACT_GotoMarkB;
				else
					action=ACT_MarkB;
				break;
			default:
				return;		
		}
		HandleAction(action);
		return;
	
	}
	
    switch (event->keyval)
	{
	
	case GDK_space:
		action=ACT_PlayAvi;
		break;
	case GDK_X:
		action=ACT_Delete;
		break;
	
	case GDK_Up:
		action=ACT_NextKFrame;
		break;
	case GDK_Down:
		action=ACT_PreviousKFrame;
		break;
			
		// Position advance
       	case GDK_Left: case GDK_KP_Left:

		// One frame
		if((shift == FALSE) && (ctrl == FALSE))
		{
			action = ACT_PreviousFrame;
		}
		// 50 frames
		else if(ctrl == TRUE)
		{
			action = ACT_Back50Frames;
		}
		// 25 frames
		else
		{
			action = ACT_Back25Frames;
		}
		break;

		// Position reverse
		case GDK_Right: case GDK_KP_Right:
		if((shift == FALSE) && (ctrl == FALSE))
		{
			action = ACT_NextFrame;
		}
		else if(ctrl == TRUE)
		{
			action = ACT_Forward50Frames;
		}
		else
		{
			action = ACT_Forward25Frames;
		}
		break;
		
		// Delete A-B section
		case GDK_Delete: case GDK_KP_Delete:
		action = ACT_Delete;
		break;
		
		// Go to first frame
		case GDK_Page_Up:  case GDK_KP_Page_Up:
		action = ACT_Begin;
		break;
		
		// Go to last frame
		case GDK_Page_Down: case GDK_KP_Page_Down:
		action = ACT_End;
		break;
		
		// Set A marker
		case GDK_Home: case GDK_KP_Home:
		action = ACT_MarkA;
		break;
		
		// Set B marker
		case GDK_End: case GDK_KP_End:
		action = ACT_MarkB;
		break;
		
		default:
		return;
		break;
	}
	
	HandleAction(action);
}

void GUI_UpdateAudioToggle(AudioSource nwsource)
{
    gchar text[300];
    switch (nwsource)
      {
      case AudioNone:
	  strcpy(text, "None");
	  break;
      case AudioAvi:
	  strcpy(text, "Avi");
	  break;
      case AudioMP3:
	  strcpy(text, "MP3");
	  break;
      case AudioWav:
	  strcpy(text, "Wav");
	  break;
      case AudioAC3:
	  strcpy(text, "AC3");
	  break;

      default:
	  assert(0);
      }

    gtk_entry_set_text((GtkEntry *) entry_faudioname, text);
}

//_____________________________
//
//_____________________________


uint8_t getRangeInMenu(GtkWidget * Menu)
{
    GtkWidget *br, *active;
    int mode;

    br = gtk_option_menu_get_menu(GTK_OPTION_MENU(Menu));
    active = gtk_menu_get_active(GTK_MENU(br));
    mode = g_list_index(GTK_MENU_SHELL(br)->children, active);
    return (uint8_t) mode;
}


// EOF
