/*
	Main file for avidemux 


 */


#include <stdlib.h>
#include <glib.h>
#include <signal.h>
#include <config.h>

#include <gtk/gtk.h>
#include <pthread.h>
#include "interface.h"
#include "support.h"
#define __DECLARE__
#include "avi_vars.h"
#include "ADM_gui/GUI_vars.h"
#include "prefs.h"

typedef void *FCT_VOID(void *);

#ifdef USE_FFMPEG
     extern "C" {
     extern void     avcodec_init(void );
     extern  void 	avcodec_register_all(void );
                       };
#endif                       

void onexit( void );
//extern void automation(int argc, char **argv);
extern int automation(void );
extern void registerVideoFilters( void );
extern void filterCleanUp( void );
extern void register_Encoders( void )  ;
extern uint8_t dloadXvid( void );
extern void ADM_audioInit(void );
extern void  buildDistMatrix( void );
extern void initScaleTab( void );
extern void initEncoders( void );
extern "C"
{
extern void     VPInitLibrary();
};

void sig_segfault_handler(int signo);
int global_argc;
char **global_argv;

int main(int argc, char *argv[])
{
// Check for big files

#ifdef     __USE_LARGEFILE	
#ifdef   __USE_LARGEFILE64	
printf("\n LARGE FILE AVAILABLE : %d offset",  __USE_FILE_OFFSET64	);
#endif
#endif




	
// thx smurf uk :)
     signal(11, sig_segfault_handler); // show stacktrace on default

    	printf("\n*******************\n");
    	printf("  VERSION " VERSION "\n");
    	printf("*******************\n");
	printf(" http://fixounet.free.fr/avidemux\n");
	printf(" Code    : Mean & JSC \n");
	printf(" GFX     : Nestor Di , nestordi@augcyl.org\n");
	printf(" Testing : Jakub Misak\n");

#ifdef USE_MMX
	printf("MMX activated.\n"); 	
#endif
   
    ADM_audioInit();

    // Probing xvid...
#ifdef USE_XX_XVID
	printf("Probing Xvid library....\n");
 	dloadXvid(  );
#endif
    VPInitLibrary();

	register_Encoders( );

    atexit(onexit);
//      g_thread_init(NULL);
    gtk_set_locale();
    gtk_init(&argc, &argv);
    gdk_rgb_init();

//  add_pixmap_directory (PACKAGE_DATA_DIR "/pixmaps");
//  add_pixmap_directory (PACKAGE_SOURCE_DIR "/pixmaps");

    /*
     * The following code was added by Glade to create one of each component
     * (except popup menus), just so that you see something after building
     * the project. Delete any components that you don't want shown initially.
     */
    window1 = create_window1();

    video_body = new ADM_Composer;
#ifdef HAVE_ENCODER
     registerVideoFilters(  );
#endif
     
#ifdef USE_FFMPEG
  
                		avcodec_init();
	                 	avcodec_register_all();
	                  
#endif
// Load .avidemuxrc
    prefs->load();
    
    buildDistMatrix();
    initScaleTab();
    initEncoders();
    loadEncoderConfig();
    
    gtk_widget_show(window1);
    if (argc >= 2)
    {
			  global_argc=argc;
			  global_argv=argv;
			  gtk_timeout_add( 300, (GtkFunction )automation, NULL );
				//automation();				
		}
   
    gtk_main();
    return 0;
}
void onexit( void )
{
	filterCleanUp();
	printf("\n Goodbye...\n\n");
}
void sig_segfault_handler(int signo)
{
     g_on_error_stack_trace ("avidemux");
//   g_on_error_query (programname);
		printf("\n***************************************");
		printf("\n***************************************");
		printf("\n***************************************");
		printf("\n If you started avidemux on a read only or ");
		printf("\n win32 partition and tried to encode or use ");
  		printf("\n Smart Copy, this crash is NORMAL");
		printf("\n This a known DivX codec bug");
		printf("\n");
		printf("\n See the avidemux homepage or the documentation ");
		printf("\n for more details on this bug");
		printf("\n***************************************");
		printf("\n***************************************");
		printf("\n***************************************");

     signo=0; // will keep GCC happy
     exit(1); // _exit(1) ???
}
