/***************************************************************************
                          op_saveprocess.cpp  -  description
                             -------------------
    begin                : Fri May 3 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr

    This piece of code is re-using part of transcode code
    http://www.theorie.physik.uni-goettingen.de/~ostreich/transcode/

    Including code from
        	Copyright (C) 2001 Christoph Lampert <gruel@gmx.de>
    		Copyright (C) Thomas streich - June 2001



 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <unistd.h>

#include <time.h>
#include <sys/time.h>

#include "fourcc.h"
#include "avi_vars.h"
#include "ADM_toolkit/toolkit.hxx"
#include "subchunk.h"
#include "avilist.h"

#include "ADM_audio/aviaudio.hxx"
#include "ADM_audiofilter/audioprocess.hxx"

#include "ADM_video/ADM_genvideo.hxx"
#include "ADM_gui/GUI_encoder.h"
#include "ADM_filter/video_filters.h"
#include "ADM_codecs/ADM_divxEncode.h"
#include "ADM_encoder/ADM_vidEncode.hxx"

#include "oplug_avi/op_aviwrite.hxx"
#include "oplug_avi/op_avisave.h"

#include "ADM_encoder/adm_encoder.h"
#include "oplug_avi/op_saveprocess.h"

//#include "encore2.h"
extern char TwoPassLogFile[300];

uint8_t
GenericAviSaveProcess::setupVideo (char *name)
{

	incoming=NULL;
   _encode=NULL;

  incoming = getLastVideoFilter ();

	// anish
 	if(incoming->getInfo()->width%8)
		{
				if(!GUI_Question("Width is not a multiple of 8\n continue anyway ?"))
					return 0;

		}

  _encode = getVideoEncoder (incoming->getInfo()->width,incoming->getInfo()->height);
  if (!_encode)
    return 0;

  // init compressor
   
 	_encode->setLogFile(TwoPassLogFile,frametogo);
  if (!_encode->configure (incoming))
    {
      delete 	_encode;
      _encode = NULL;
      GUI_Alert ("Init of filter failed");
      return 0;
    };
 
  memcpy (&_bih, video_body->getBIH (), sizeof (_bih));
  _bih.biWidth = incoming->getInfo ()->width;
  _bih.biHeight = incoming->getInfo ()->height;
  _bih.biSize=sizeof(_bih);
  _bih.biXPelsPerMeter=_bih.biClrUsed=_bih.biYPelsPerMeter=0;
  printf("\n Saved as %ld x %ld\n",_bih.biWidth,_bih.biHeight);
 	memcpy(&_bih.biCompression	,_encode->getCodecName(),4);
   
  // init save avi
//-----------------------VBR--------------------------------------
  if (_encode->isDualPass ())
    {
      uint8_t *buffer;
      uint32_t len, flag;
      FILE *tmp;
	uint8_t reuse=0;

 

	if((tmp=fopen(TwoPassLogFile,"rt")))
	{
		fclose(tmp);
		if(GUI_Question("\n Reuse the existing log-file ?"))
		{
			reuse=1;
		}
	}
	
	if(!reuse)
 	{
       guiStart();
      guiSetPhasis ("1st Pass");
     buffer = new uint8_t[incoming->getInfo ()->width *
		    incoming->getInfo ()->height * 3];

      _encode->startPass1 ();
      //__________________________________
      //   now go to main loop.....
      //__________________________________

      for (uint32_t cf = 0; cf < frametogo; cf++)
	{
	  if (guiUpdate (cf, frametogo))
	    {
	    abt:
	      GUI_Alert ("Aborting!");
//	      guiStop ();
	      delete[]buffer;
	      return 0;
	    }

	  if (!_encode->encode (frameStart + cf, &len, buffer, &flag))
		{
			printf("\n Encoding of frame %lu failed !\n",cf);
	    		goto abt;
		}

	}
//      guiStop ();
      delete[]buffer;

    }// End of reuse

      if(!_encode->startPass2 ()) return 0;
   }   //-------------------------/VBR-----------------------------------
  // init save avi

// now we build the new stream !
    	
	
		memcpy(&_videostreamheader,video_body->getVideoStreamHeader (),sizeof(_videostreamheader));
		memcpy(&_videostreamheader.fccHandler	,_encode->getFCCHandler(),4);
    memcpy(&_mainaviheader	,video_body->getMainHeader (),sizeof(_mainaviheader));
    _mainaviheader.dwWidth=_bih.biWidth;
    _mainaviheader.dwHeight=_bih.biHeight;
    _videostreamheader.dwQuality=10000;
    
    uint8_t *data;
    uint32_t dataLen=0;
    
    _encode->hasExtraHeaderData( &dataLen,&data);
    if(!dataLen)
    {								    
  	if (!writter->saveBegin (name,
			   &_videostreamheader,
			   (uint8_t *)&_bih,
			   sizeof(_bih),
			   (AVDMGenericAudioStream *) audio_filter,
			   &_mainaviheader,
			   frameEnd - frameStart + 1))
    {

      return 0;
    }
  } // else extra data
    // in bih field -> huffyuv etc...
  else
  {
  	uint32_t totalLen=sizeof(_bih)+dataLen;
  	uint8_t *bih=new uint8_t[totalLen];
	assert(bih);
	_bih.biSize=totalLen;
	memcpy(bih,&_bih,sizeof(_bih));
	memcpy(bih+sizeof(_bih),data,dataLen);
  	if (!writter->saveBegin (name,
			   &_videostreamheader,
			   bih,
			   totalLen,
			   (AVDMGenericAudioStream *) audio_filter,
			   &_mainaviheader,
			   frameEnd - frameStart + 1))
    	{
		delete [] bih;
      		return 0;
    	}
	delete [] bih;
  	
  
  }
  return 1;
  //---------------------
}

//
//      Just to keep gcc happy....
//
GenericAviSaveProcess::~GenericAviSaveProcess ()
{
  if (_encode)
    delete      _encode;

}

// copy mode
// Basically ask a video frame and send it to writter
uint8_t
GenericAviSaveProcess::writeVideoChunk (uint32_t frame)
{
  uint32_t    len1;
  uint8_t    	ret1;


  // CBR or CQ


  if (frame == 0)
	{
	  GUI_encoderSetCodec((char *)_encode->getDisplayName())  ;
    	if (!_encode->isDualPass ())
      	{
				guiSetPhasis ("Encoding");
	      }
    	else
      		{
				guiSetPhasis ("Encoding, 2nd pass");
	      }
	}
  // first read                   
  ret1 = _encode->encode (frameStart + frame, &len1, vbuffer, &_videoFlag);
  if (!ret1)
    return 0;
  // check for split
     // check for auto split
      // if so, we re-write the last I frame
      if(muxSize)
      	{
				 		// we overshot the limit and it is a key frame
				   	// start a new chunk
				  	if(handleMuxSize() && (_videoFlag & AVI_KEY_FRAME))
				   	{							   
							if(!reigniteChunk()) return 0;
						}
				 }
  return writter->saveVideoFrame (len1, _videoFlag, vbuffer);

}

void
GenericAviSaveProcess::guiStart (void)
{
  GUI_encoderStart ();
  GUI_encoderSetFrame (0, 100);
}

void
GenericAviSaveProcess::guiStop (void)
{
  GUI_encoderStop ();

}

void
GenericAviSaveProcess::guiSetPhasis (const char *n)
{
  GUI_encoderSetPhasis (n);
}

uint8_t
GenericAviSaveProcess::guiUpdate (uint32_t nb, uint32_t total)
{
  GUI_encoderSetFrame (nb, total);
  if (GUI_encoderIsAlive () == 1)
    return 0;
  return 1;

}

// EOF
